c----------------------------------------------------------------------------c
*... author : Serge Slabospitsky                                             *
*... 21.07.2006                                                              *
*                                                                            *
      SUBROUTINE TXPAREAD   !(fkey) 
*     ------------------------------------                                   *
*  The data file should has the following form.                              *
*                                                                            *
* 1. totally blank card is ignored                                           *
* 2. comment card has a first non-blank character the single symbol '*',     *
*    the further contents of the card are ignored                            *
* 3. The data-card should has the following format:                          *
*   'variable's name' '=' 'variable's value' 'comment (not needed)'          *
* 4. the card without '=' character will be readed but not recognized        *
*............................................................................*
      implicit none
      integer nfil                ! number of external data files
      parameter (nfil=10)
      integer LUNfil(nfil)        ! input channel for reading CMSJET param
      character *80 filnam(nfil)  ! Name of the file
      data lunfil/71, 77, -1, -1, -1
     &          , -1, -1, -1, -1, -1/
      data filnam /'txrun.dat', 'cmsjet.dat', 'cmsrun.dat', 'xx', 'xx'
     &             ,'xx',     'xx',        'xx', 'xx', 'xx'/

      integer lundat
      character *80 TXname       ! name of the input data file 
      character *6 fkey, fnam(nfil)
      data fnam/'trxdat', 'cmsjet', 'cmsrun', 'xxxxxx', 'xxxxxx'
     &         ,'xxxxxx', 'xxxxxx', 'xxxxxx', 'xxxxxx', 'xxxxxx'/

      character *80 vv, vst(nfil,400), aa 
      integer kin(nfil), I, j1, ifil 
      logical first, firsf(nfil)
      data first /.TRUE./
      save first, firsf
*

      fkey = 'trxdat'

      
      if(first) then 
        do i = 1, nfil
         firsf(i) = .true.
        enddo
       first = .false.
      endif
*
      IFIL = -1
      lundat = -1
      do i = 1, 6
       if(ichar(fkey(i:i)).ge.65.AND.ichar(fkey(i:i)).LE.90) then
         fkey(j1:j1) = char(ichar(fkey(j1:j1))+32)
       endif
      enddo

       do i = 1, nfil
        if(fkey(1:6).eq.fnam(i)(1:6)) then
         ifil = i
         lundat = lunfil(i)          
         txname = filnam(i)
        endif
       enddo
       if(lundat.eq.-1) goto 200

      if(.NOT.firsf(ifil))  goto 999 
      open(lundat, FILE=txname, status='old',form='formatted',ERR=200) 
      kin(ifil) = 0
 101  continue 
      read(lundat,'(a)',end=998,err=998) aa 
        if(aa(1:1).eq.'C') goto 101   ! this is a comment card, ignored 
       do i = 1,80
        if(aa(i:i).ne.' ') then 
         j1 = 1  ! non-blank character
         if(aa(i:i).eq.'*') goto 101  ! first non-blank item = '*' -  comment
         goto 16
        endif        
       enddo
       goto 101 !  blank string 
 16    j1 = 0
       do i = 1,80
       if(aa(i:i).ne.' ') then 
         if(aa(i:i).eq.'='.and.j1.eq.0) j1 = i
        endif
      enddo
      if(j1.eq.0) goto 101 ! all items are blanck symbols or there is no '='
        kin(ifil) = kin(ifil) + 1
        vst(ifil,kin(ifil))(1:80) = aa(1:80)
       goto 101
 998   continue
        firsf(ifil) = .FALSE.
        close(lundat)
 999  continue
        DO i = 1,kin(ifil)
         vv = vst(ifil,i)
         call txgive(vv)      
        enddo
       return
 200  continue
      return
      END
*----------------------------------------------------------------------------*
