*----------------------------------------------------------------------------*
      FUNCTION APPPM(S,T,U,EMZ2,EQ2,B,A2PB2,A2MB2)
      IMPLICIT REAL*8(A-H,O-Z)
      double complex APPPM
      COMPLEX*16 BI(4),CI(4),DI(3)
      COMMON/CINTS/BI,CI,DI
      Y=U*T-EMZ2**2
      S4=S-4.D0*EMZ2
      S2=S-2.D0*EMZ2
      T1=T-EMZ2
      U1=U-EMZ2
      APPPM=A2PB2*
     1 (-8.D0*S2*Y/S4/U1/T1
     2  +8.D0*EMZ2/S4*BI(2)*((1.D0+2.D0*T/S)-S4/T1-EMZ2*S2/T1**2)
     3  +8.D0*EMZ2/S4*BI(3)*((1.D0+2.D0*U/S)-S4/U1-EMZ2*S2/U1**2)
     4  +16.D0*EMZ2*Y/S**2/S4*(U1*CI(3)+T1*CI(2))
     5  -16.D0*EQ2/S4*(S2*CI(1)
     6       +(S4*U1/S+2.D0*EMZ2**2/U1)*CI(3)
     7       +(S4*T1/S+2.D0*EMZ2**2/T1)*CI(2))
     8  -8.D0*EMZ2*Y**2/S**2/S4*DI(3)
     9  +8.D0*EQ2/S4*((S-6.D0*EMZ2)*Y/S*DI(3)
     1                -2.D0*EMZ2**2*(DI(2)+DI(1)))
     2  +16.D0*EQ2**2*(DI(3)+DI(2)+DI(1))
     3  +8.D0*EQ2*S/Y*(S2*CI(1)+S4*CI(4)
     4                +2.D0*U**2/U1*CI(3)+2.D0*T**2/T1*CI(2)
     5                +T**2*DI(1)+U**2*DI(2)))
      RETURN
      END
