*----------------------------------------------------------------------------*
      FUNCTION CI2(A,B,Y0)
C
C     INTEGRAL  LOG(A-IEPS-BY(1-Y))/(Y-Y0)
C
      REAL*8 A,B,Y0
      double complex CI2
      COMPLEX*16 EPS,SP,Y1,Y2
      COMMON/SMALL/EPS
      IF(B.EQ.0.D0)THEN
        CI2=(0.D0,0.D0)
        RETURN
      ENDIF
C     Y1=(B+CDSQRT(B*B-4.D0*B*(A+EPS)))/2.D0/B
      Y1=0.5D0*(1.D0+CDSQRT(1.D0-4.D0*(A+EPS)/B))
      Y2=1.D0-Y1
      CI2=SP(Y0/(Y0-Y1))-SP((Y0-1.D0)/(Y0-Y1))+
     1    SP(Y0/(Y0-Y2))-SP((Y0-1.D0)/(Y0-Y2))
      RETURN
      END
