c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  06.09.2002                                  *
* Single top: t-channel : 2 -> 3                                             *
*   TopReX code = 2                                                          *
*   color flow and showering description for PYTHIA                          *
      subroutine COLORF_02(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      Integer I, Iglu, iqrk, ip1, ip2, iwkf, iqp
      integer ntop, kpp(2), kftop(2) 
*............................................................................*
*....  particles description                                                 *
*...                                                                         *
*     g(q)[1] ---------O------------- q`[3]                                  *
*                      <                                                     *
*                      >  W* (t-channel)                                     *
*                      <                                                     *
*                      O============= t[5]                                   *
*                      |                                                     *
*                      |                                                     *
*                      |                                                     *
*     q(g)[2] ~~~~~~~~~O------------- Bbar[4]                                *
*............................................................................*

* HEPEUP          1     2       3   4     5     
*       nup = 5 ! g(q)  q(g) -> q'  Bbar  t(t~) 
* how PYTHIA will be treated
        istup(3) =  1 ! final q'
        istup(4) =  1 ! final Bbar from initial gluon splitting
        istup(5) =  2 ! top, not to be treated by PYTHIA
* parent's lines
          mothup(1,3)=1  ! final q' 
          mothup(2,3)=2  !
           mothup(1,4)=1  ! final bbar 
           mothup(2,4)=2  !
            mothup(1,5)=1  ! final top 
            mothup(2,5)=2  !
* KF code
* Iglu is No of lines of initial gluon 
        if(ip1.eq.0) then
* GLUON and quark initial state
         Iglu = 1
         iqrk = 2
         idup(1) = 21  
         idup(2) = ip2
         iwkf = ip2
        else
* QUARK and gluon initial state
         Iglu = 2
         iqrk = 1
         idup(1) = ip1  
         idup(2) = 21
         iwkf = ip1
        endif
         call qflqw(iwkf, iqp)
* now IWKF is W-boson PYTIA code, +24/-24 = W+/W- = top/top_bar production
        idup(3) = iqp
        pup(5,3)  = mq(abs(iqp))
       
* KF codes and COLOR FLOW for final B1[4] 
        ipar(50) = 300
         if(iqp.gt.0) then  ! initial quark
           icolup(1,iqrk) = ipar(50)+1       
           icolup(1,3)    = icolup(1,iqrk)
         else               ! initial  
           icolup(2,iqrk) = ipar(50)+1       
           icolup(2,3)    = icolup(2,iqrk)
         endif
        ipar(50) = ipar(50) + 100
          icolup(1,iglu) = ipar(50) + 1
          icolup(2,iglu) = ipar(50) + 2

        if(Iwkf.eq.+24) then    
* top     decay: t[5] and bbar[4]
         idup(5) =  6         ! top 
         idup(4) = -5         ! B_bar
          icolup(1,5) = icolup(1,iglu)
          icolup(2,4) = icolup(2,iglu)
        else
* top_bar decay: tbar[5] and b[4] 
         idup(5) = -6         ! top_bar
         idup(4) =  5         ! B
          icolup(2,5) = icolup(2,iglu)
          icolup(1,4) = icolup(1,iglu)
        endif
* 
      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
        ntop = ntop + 1
        kpp(ntop) = I
        kftop(ntop) = idup(i)
       endif 
      enddo
       if(ntop.ge.1) then
        call top_decay(ntop, kpp, kftop) 
       endif
      return
      end
