*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  31.01.2001                                  *
*   H+- JET   production                                                     *
*   TopReX code = 7                                                          *
*   color flow and showering description for PYTHIA                          *
*............................................................................*
      subroutine COLORF_07(i1, i2)
*     --------------------------------                                       *
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      integer i1, i2, IKF, iglu, iqrk, ik
      common /hjetfl/ ik(3) 
*.............  H JET  process   .......................
*...
*                                                        
*     q(q~)[1]\ ~~~~~~~~~~~~~~~~~~~~~~~~  final q or G [3]
*              \                         
*               \                 /   NU [5]  
*                \               /      
*                 O/\  H [4]  /\O    
*                /               \
*               /                 \
*     q~(q)[2] /                   \ TAU [6]
*                                      
*...........................................................
*                 1      2        3   4        5    6
*      nup=6    ! q(q~)  q~(q) -> q   H(W) ->  NU  TAU   
* how PYTHIA will be treated
        istup(3) =  1 ! final parton 
        istup(4) =  2 ! virtual boson
        istup(5) =  1 ! final NU 
        istup(6) =  1 ! final TAU
* parent's lines
          mothup(1,3)=1  ! final Q
          mothup(2,3)=2  !
        mothup(1,4)=1  ! final W 
        mothup(2,4)=2  !
        mothup(1,5)=4  ! final NU 
        mothup(2,5)=4  !
        mothup(1,6)=4  ! final TAU 
        mothup(2,6)=4  !
* KF code
        if    (abs(ipar(21)).eq.1) then
          idup(4) = -24 
        elseif(abs(ipar(21)).eq.2) then
          idup(4) = -37
        else
          idup(4) = 94
        endif
       if(i1.eq.2.OR.i1.eq.4.OR.i1.eq.-1.OR.i1.eq.-3.OR.i1.eq.-5.
     & or.i2.eq.2.OR.i2.eq.4.OR.i2.eq.-1.OR.i2.eq.-3.OR.i2.eq.-5)
     & idup(4) = -idup(4) 
       if(idup(4).gt.0)    then
        idup(5) =  16   ! H+, W+
        idup(6) = -15
       else
        idup(5) = -16   ! H-, W-
        idup(6) =  15
       endif 
* color flow
       ipar(50) = 300
*       ikf = abs(ik(3))
      IF    (i1.EQ.0.OR.i2.EQ.0) THEN  ! gluon + quark 
        if(i1.eq.0) then
         iglu = 1
         iqrk = 2
         idup(2) = i2
         ikf = abs(ik(3))
         if(i2.lt.0) ikf = -ikf
        elseif(i2.eq.0) then
         iglu = 2
         iqrk = 1
         idup(1) = i1
         ikf = abs(ik(3))
         if(i1.lt.0) ikf = -ikf
        endif
         idup(iglu) = 21  ! initial gluon 
         idup(3) = ikf ! flavor of final quark
*  colors
          icolup(1,iglu) = ipar(50) + 1   ! gluon color
          icolup(2,iglu) = ipar(50) + 2   ! gluon anticolor
         if    (ikf.gt.0) then
          icolup(1,iqrk) = icolup(2,iglu)    ! from gluon
          icolup(1,3)    = icolup(1,iglu)    ! from gluon
         else 
          icolup(2,iqrk) = icolup(1,iglu)    ! from gluon
          icolup(2,3)    = icolup(2,iglu)    ! from gluon
         endif
      ELSEIF(i1.NE.0.and.i2.NE.0) then
* quark + antiquark in the initial state
        idup(1) = i1   ! initial quark 
        idup(2) = i2   ! initial quark
        idup(3) = 21   ! flavor of final gluon 
         icolup(1,3) = ipar(50) + 1
         icolup(2,3) = ipar(50) + 2
       if(i1.gt.0) then
         icolup(1,1) = icolup(1,3) 
         icolup(2,2) = icolup(2,3) 
       else 
         icolup(2,1) = icolup(2,3) 
         icolup(1,2) = icolup(1,3) 
       endif
      endif
      return
      end
