*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  01.06.2006                                  *
* FCNC : 2 -> 2                                                              *
*   TopReX code = 31                                                         *
      subroutine COLORF_31(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer I, ip1, ip2, ntop, kpp(2), kftop(2), JJ 
      integer kft, kfm, kf3 
*....... FCNC q q -> t q ....................................................*
*     q   [1] ---------O----------  q[3]                                     *
*                      <                                                     *
*                      <                                                     * 
*     q   [2] ---------O==========  T [4]                                    *
*............................................................................*

* HEPEUP :        1     2       3     4 
*       nup = 4 
* how PYTHIA will be treated
        istup(4) =  2 ! final top 
        istup(3) =  1 ! final q
* parent's lines
          mothup(1,3)=1  ! final q
          mothup(2,3)=2  !
           mothup(1,4)=1  ! final top
           mothup(2,4)=2  !
*
       call Razbor_14(ip1, ip2, kft, kfm, kf3) 

          idup(3) = kf3
          idup(4) = kft
* color's flow
        ipar(50) = 300
         if(idup(4).eq.6) then
          JJ = 1
           I = 0
         else
          JJ = 0
           I = 1
         endif
          icolup(1,4) = JJ*ipar(50) ! color 
          icolup(2,4) =  I*ipar(50) ! anticolor 
       
         if(idup(kfm).gt.0) then
          JJ = 1
           I = 0
         else
          JJ = 0
           I = 1
         endif
          icolup(1, kfm) = JJ*ipar(50) ! color 
          icolup(2, kfm) =  I*ipar(50) ! anticolor 
        ipar(50) = ipar(50) + 1
*
      If(kfm.eq.3) then
       if(ip1.gt.0) then
         icolup(1,1) = ipar(50)     !q1 color 
         icolup(2,1) = 0            !q1 anti color 
         icolup(1,2) = 0            !q2 color 
         icolup(2,2) = ipar(50)     !q2 anti color 
       else 
         icolup(1,1) = 0            !q1 color 
         icolup(2,1) = ipar(50)     !q1 anti color 
         icolup(1,2) = ipar(50)     !q2 color 
         icolup(2,2) = 0            !q2 anti color 
       endif
      Else
       JJ = 3 - kfm
       if(idup(3).gt.0) then
         icolup(1,JJ) = ipar(50)     !q1 color 
         icolup(2,JJ) = 0            !q1 anti color 
         icolup(1,3)  = ipar(50)     !q2 color 
         icolup(2,3)  = 0            !q2 anti color 
       else 
         icolup(1,JJ) = 0            !q1 color 
         icolup(2,JJ) = ipar(50)     !q1 anti color 
         icolup(1,3)  = 0            !q2 color 
         icolup(2,3)  = ipar(50)     !q2 anti color 
       endif
      EndIf
*
      
*      call hardinfo

 


      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
        ntop = ntop + 1
        kpp(ntop) = I
        kftop(ntop) = idup(i)
       endif 
      enddo
       if(ntop.ge.1) then
        call top_decay(ntop, kpp, kftop) 
       else 
        STOP ! no top quark
       endif
      return
      end
