
c----------------------------------------------------------------------------c
      function dLi2(x)
      implicit none
      double complex dLi2
      double complex spen0, x, x1, x2 
      double complex e05 
      double complex e0, e1, ei  ! 0, 1 i
      common /cunits/ e0, e1, ei
      data e05/(0.5d0,0.d0)/
      save e05
      double precision ax
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*
       dLi2 = e0
       if(x.eq.e0) then
        return
       elseif(x.eq.e1) then
         dLi2 = pi**2/6.d0
          return
       elseif(x.eq.-e1) then
         dLi2 = -pi**2/12.d0
          return
       elseif(x.eq.ei) then
         dLi2 = -pi**2/48.d0 + ei*0.915965594
          return
       elseif(x.eq.-ei) then
         dLi2 = -pi**2/48.d0 - ei*0.915965594
          return
       elseif(x.eq.e05) then
         dLi2 = pi**2/12.d0 - e05*(dlog(2.d0))**2
          return
       endif 

      ax = cdabs(x)
      if(ax.le.1.0d0) then
       dLi2 = spen0(x)
      else 

*      if(DREAL(X).lt.0.d0.and.DIMAG(X).eq.0.d0) x = x + ei*ax*0.00001
      if(DIMAG(X).eq.0.d0) x = x + ei*ax*0.00001
      If(dreal(x).gt.0.d0) then 
       x1 = 1.d0 - x
       dLi2 = pi**2/6.d0 - cdlog(x)*cdlog(1.d0-x)     
        if((cdabs(x1)**2).le.1.d0) then
         dLi2 = dLi2 -spen0(x1) 
        else
         x2 = 1.d0/(1.d0 - x1)
         dLi2 = dLi2 - (spen0(x2) + 0.5*(cdlog(1.d0-x1))**2 
     & -cdlog(-x1)*cdlog(1.d0-x1) - pi**2/6.d0)
         endif
       Else 
       x1 = 1.d0/(1.d0 - x)
       dLi2 = spen0(x1) + 0.5*(cdlog(1.d0-x))**2 
     & -cdlog(-x)*cdlog(1.d0-x) - pi**2/6.d0
       endif
      Endif

      return
      end
