
*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   20/11/2000                                 *
*....                                                                        *
      subroutine EPSPR(A, B, C, V)
*     ------------------------------                                         *
*                                                                            *
*  V(nu) = epsilon(nu, al, bl, cl) A(al) B(bl) C(cl)                         *
* A, B, C are vectors                                                        *
*............................................................................*
      implicit None
      double precision A(5), B(5), C(5), V(4)
*
      V(4) =   A(1) * (B(2)*C(3) - B(3)*C(2))
     &       - A(2) * (B(1)*C(3) - B(3)*C(1))
     &       + A(3) * (B(1)*C(2) - B(2)*C(1))
      V(1) = - A(4) * (B(2)*C(3) - B(3)*C(2))
     &       + A(2) * (B(4)*C(3) - B(3)*C(4))
     &       - A(3) * (B(4)*C(2) - B(2)*C(4))
      V(2) =   A(4) * (B(1)*C(3) - B(3)*C(1))
     &       - A(1) * (B(4)*C(3) - B(3)*C(4))
     &       + A(3) * (B(4)*C(1) - B(1)*C(4))
      V(3) = - A(4) * (B(1)*C(2) - B(2)*C(1))
     &       + A(1) * (B(4)*C(2) - B(2)*C(4))
     &       - A(2) * (B(4)*C(1) - B(1)*C(4))
      return
      end
