*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  09/01/2001                                  *
* Single top: t-channel : 2 -> 3                                             *
*   TopReX code = 2                                                          *
      subroutine gejzer_02(NFP)
*     --------------------                                                   *
*............................................................................*
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision  p1(5),  pq(5),  pb(5) 
      double precision  pp1(5), pq1(5), pb1(5) 
      double precision  q1(5), q2(5), qq(5)
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer I, J, j1,j2
      double precision mq, mq2
      common /massql/  mq(0:20), mq2(0:20)
      double precision  x1, x2, sg, sgs
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision fqwq
      common  /sng1fc/ fqwq(4)   !  is factor for weigh  
      double precision  pdfBT(-5:5, -5:5)
      double precision  Veslum, VesGU, vesUG
      integer ich                        ! mark for W-boson exchange
      save ich
      double precision ParL(3) ! , TopMV
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision wgSUM(-5:5)
      save wgSUM 
      integer         MSTP,               MSTI 
      double precision          PARP,               PARI      
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
*.......
      double precision p0, ps(5), wtR, ves2, pyr, pt
      integer imatch
      common /wmtch/imatch 
*
      IF(first) THEN
       if(txsel.eq.1) mstp(143) = 1
*       if(txpro(1).eq.1.and.txpro(2).eq.1) mstp(143) = 1
       ich = +1          ! W-boson exchaneg in T-channel
      I = 1
      J = 1
      Call qflqw(I, J)
        wgSUM(2) = BRS(1,1) 
        wgsum(4) = wgSUM(2)
        wgSUM(1) = BRS(2,1) 
        wgsum(3) = wgSUM(1)
        wgsum(-1) = wgSUM(2)
        wgsum(-2) = wgSUM(1)
        wgsum(-3) = wgSUM(2)
        wgsum(-4) = wgSUM(1)
* 
*  special cuts for Ipar(1) = 11. 
*  Rpar(81) = minPT for light quark,     LHC: Rpar(81) = Rpar(68) = 20 GeV
*  Rpar(82) = minPT for additional Bbar, LHC: Rpar(82) = Rpar(69) = 10 GeV
*            Rpar(81) = Rpar(68) ! PTmin for q
*            Rpar(82) = Rpar(69) ! PTmin for bbar
*        EndIf 
        If(txsel.eq.1)  then
            Rpar(81) = Rpar(68) ! PTmin for q
            Rpar(82) = Rpar(69) ! PTmin for bbar
        EndIf 
       first=.FALSE.
      ENDIF

      sigrx=0.d0
      imatch = 2
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
* evaluate of the top on-shell mass
*      p1(5) = TopMV(Rpar(34), mq(6))
       p1(5) = mq(6)
       Parl(1) = p1(5) + mq(5) 
       ParL(2) = Rpar(1)
       ParL(3) = Rpar(1)
 919  call X1X2GEN( ParL, X1, X2, Veslum, q1, q2, QQ)

      call Mass2(q1, q2, sg, sgs)

      pq(5) = 0.d0
      pb(5) = mq(5)
      if(pyr(0).ge.0.5) then
       p0 = p1(5) 
       call LIPS_QG(QQ, pb, ps, p0, wtR) 
       call LIPS2(PS, pq, p1, ves2)
       call TXQscale     
       call sng_02(ich, q1, q2,  pq, p1, pb, vesGU)
       vesGU = VesGU * wtR * ves2 * Veslum * pi2_4 / (2.d0*sg)
       vesGU = 2.d0 * vesGU    ! due to two variants
       vesUG = 0.d0
      else
       p0 = -p1(5) 
       call LIPS_QG(QQ, pb, ps, p0, wtR)
       call LIPS2(PS, pq, p1, ves2)
       call TXQscale     
       call sng_02(ich, q2, q1,  pq, p1, pb, vesUG)
       vesUG = VesUG * wtR * ves2 * Veslum * pi2_4 / (2.d0*sg)
       vesUG = 2.d0 * vesUG    ! due to two variants
       vesGU = 0.d0
      endif
* fill momenta matrix  for PYTHIA treatment (HEPEUP)
* additional cut on pt(qprime)

       if(pt(pq).lt.Rpar(81).or.pt(pb).lt.Rpar(82)) then
          NXev(2) = NXev(2) + 1
          goto 919  !PT of final q-quark 
       endif

      call pdf_BT(x1, x2, pdfbt) 

      do I = 1,4
       J = -I
       xcs(0, I) = VesGU * pdfBT( 0, I) * fqwq(I) * wgSUM(I) 
       xcs(0, J) = VesGU * pdfBT( 0, J) * fqwq(I) * wgSUM(J) 
       xcs(I, 0) = vesUG * pdfBT( I, 0) * fqwq(I) * wgSUM(I) 
       xcs(J, 0) = vesUG * pdfBT( J, 0) * fqwq(I) * wgSUM(J)
      enddo
       
       sigrx=0.d0
       do i=-5,5
        do j=-5,5
         sigrx=sigrx+xcs(i,j)
        enddo
       enddo
* fill momenta array
        call TXTQ2SMR(QQ, p1, pb, pq, pp1, pb1, pq1)
       NFP = 5
       do i = 1, 5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = pq1(i)       ! final light quark
        pus(4,i) = pB1(i)       ! bbar 
        pus(5,i) = pp1(i)       ! top
       enddo
      return
      end
