
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  23.11.2005                                  *
*  t tbar gamma
*............................................................................*
      subroutine gejzer_25(NFP) 
      Implicit None
      include "txpar.inc"  
      include "txpro.inc" 
      integer NFP          ! number of particles in hard process 
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      integer I, J, j1,j2
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision q1(5), q2(5), qq(5), p1(5), p2(5), q(5)
      common /txkin/q1, q2, QQ
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, PT, ptmin
*      data ptmin/10.d0/
      save ptmin
      double precision Parl(3), vlum, vesl, vesD, vesU, vesG
      double precision vhh(3,3), vtt3
      common /topol2gam/ vtt3(3,3,3)
      integer jj1, jj2, jj3     
      double precision pdfBT(-5:5, -5:5)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision qtt(5), pp1(5), pp2(5), massone
*.......
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*..
      IF(first) THEN
        first=.FALSE.
           ptmin = 5.d0
         if(ptmin.ge.rpar(103)) then
           ptmin = 5.d0 ! 
         else
           ptmin = rpar(103)
         endif
       PARL(1) = 2.d0*mq(6) + ptmin
       PARL(2) = Rpar(1)      ! max sqrt(S_hat) 
       PARL(3) = Rpar(1)      ! sqrt(S) 
      print*,' t tbar gamma:  PT(gamma)_min = ',ptmin,'GeV'
      ENDIF
 
*..........................................
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
      p1(5) = mq(6)
      p2(5) = mq(6)
      q(5)  = 0.d0
 502  continue  
      call zer5mom(q1) 
      call zer5mom(q2) 
      call X1X2GEN( Parl, X1, X2, Vlum, q1, q2, QQ)
      vlum = vlum * pi2_4 / (2.*QQ(5)**2)
*      call LIPS3(QQ, p1, p2, q, VesL)
      call LIPS3_TTG(QQ, ptmin, p1, p2, q, VesL)

      if(pt(q).le.ptmin) then
          NXev(ipar(1)) = NXev(ipar(1)) + 1
          goto 502  !PT of final q-quark 
       endif
*
 333  continue
       do 123 jj1 = 1,3
       do 123 jj2 = 1,3
       do 123 jj3 = 1,3
 123      vtt3(jj1,jj2,jj3) = 0.d0

      if(Ipar(22).eq.0.or.Ipar(22).eq.2) then  ! q qbar contribution
       call qqttgam(2, q1, q2, p1, p2, q, Vhh, vesU)
        do i = 1,3
         do j = 1,3
          vtt3(2,i,j) = vhh(i,j)  ! U Ubar -> t tbar
         enddo
        enddo
       call qqttgam(1, q1, q2, p1, p2, q, Vhh, vesD)
        do i = 1,3
         do j = 1,3
          vtt3(3,i,j) = vhh(i,j)  ! qq-> t tbar
         enddo
        enddo
      else
        vesU = 0.d0  ! ipar(1) = 21 : no qq~ contribution
        vesD = 0.d0  ! ipar(1) = 21 : no qq~ contribution
      endif
*...
      if(Ipar(22).eq.0.or.Ipar(22).eq.1) then  ! gg contribution
       call ggttgam(   q1, q2, p1, p2, q, Vhh, vesG)
        do i = 1,3
         do j = 1,3
          vtt3(1,i,j) = vhh(i,j) ! gluon
         enddo
        enddo
      else
        vesG = 0.d0  ! ipar(1) = 22 : no gg contribution
      endif
*.............
      
      vesG = vesl*vlum*vesG * BRS(1,1) * BRS(2,1) 
      vesD = vesl*vlum*vesD * BRS(1,1) * BRS(2,1) 
      vesU = vesl*vlum*vesU * BRS(1,1) * BRS(2,1) 
**
* setting Q-scale for PDF( Rpar(3)) and for alpha_s 
 2222 Rpar(76) = p1(1)**2 + p1(2)**2 ! pt(top)
      Rpar(75) = dsqrt(Rpar(76))   
      call TXQscale     
      call pdf_BT(x1, x2, pdfBT) 
***

      xcs( 0, 0) = vesG * pdfBT( 0, 0)
      xcs( 1,-1) = vesD * pdfBT( 1,-1)
      xcs(-1, 1) = vesD * pdfBT(-1, 1)
      xcs( 3,-3) = vesD * pdfBT( 3,-3)
      xcs(-3, 3) = vesD * pdfBT(-3, 3)
      xcs( 5,-5) = vesD * pdfBT( 5,-5)
      xcs(-5, 5) = vesD * pdfBT(-5, 5)
      xcs( 2,-2) = vesU * pdfBT( 2,-2)
      xcs(-2, 2) = vesU * pdfBT(-2, 2)
      xcs( 4,-4) = vesU * pdfBT( 4,-4)
      xcs(-4, 4) = vesU * pdfBT(-4, 4)

      sigrx=0.d0
      do i = -5,5
        do j=-5,5
          sigrx = sigrx + xcs(i,j)
        enddo
      enddo

      NFP = 5
        do i=1,4
         qtt(i) = p1(i) + p2(i)
        enddo
         qtt(5) = massone(qtt)
       call TXTTSMR(QTT, p1, p2, pp1, pp2)
        do i=1,5
          pus(1,i) = q1(i)
          pus(2,i) = q2(i)
          pus(3,i) = pp1(i)         ! top quark 
          pus(4,i) = pp2(i)         ! top_bar quark 
          pus(5,i) = q(i)          ! photon 
        enddo
*          call  EXAM_ttgam

       return
      end
