*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  01/06/2006                                  *
* TopReX code = 14,  q q -> T q, fcnc, gluon                                 *
*............................................................................*
      subroutine gejzer_31(NFP) 
      Implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision p1(5),p2(5), p3(5), p4(5), pft(5),pfq(5),qq(5)
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs, PT
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision Ves, vlum, du1, dc1, uu1, uu2, cc1, cc2
      double precision pq1(5), pq2(5), pq3(5)
      integer ID1, i, j
      double precision pdfBT(-5:5, -5:5)
      integer iq1, iq2, iq3, ncl, j8,j9
      double precision HR(4), pyr 
      integer       idum,     idf 
      double precision                 ved,     HRD 
      common /tplFC/idum(16), idf(16), ved(16), HRD(16,4)
      save /tplfc/
      integer imatch
      common /wmtch/imatch 
*.......
      double precision Parl(3) !, TopMV
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*..........................      
      if(first) THEN
       first=.FALSE.
        if(mid(11,1).eq.-1.AND.mid(12,1).eq.-1) then 
         print*,' '
         print*,'TopReX  FCNC process  ',ipar(1)
         print*,' FCNC (top -> !UP+CHARM! gluon) is switched OFF'
         print*,' stop TopReX run '
         STOP
         return
        endif 
        If(txsel.eq.2)  then
            Rpar(81) = Rpar(68) ! PTmin for q
        Else
            Rpar(81) = Rpar(103) ! PTmin for q
        EndIf 
         if(rpar(81).le.1.d0) rpar(81) = 1.d0
         print*,'TopReX process ',Ipar(1),' PTmin ',Rpar(81)
      ENDIF

      imatch = 2
      sigrx=0.d0
      do j8 = -6,6
      do j9 = -6,6
       XCS(j8,j9) = 0.d0
      enddo
      enddo
      call zer5mom(p1) 
      call zer5mom(p2) 

*
       p4(5) = mq(6)
       p3(5) = 0.d0
       Parl(1) = p3(5) + p4(5) 
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)
 100   call X1X2GEN( Parl, X1, X2, Vlum, p1, p2, QQ)
      
      call mass2(p1, p2, sg, sgs)
      Call LIPS2(QQ, P3, P4, ves)
       if(PT(p3).lt.Rpar(81)) then
          NXev(Ipar(1)) = NXev(ipar(1)) + 1
          goto 100
       endif
      Ves = Vlum * Ves * pi2_4 / (2.* sg)
      Rpar(76) = p4(1)**2 + p4(2)**2     ! pt(top)
      Rpar(75) = dsqrt(Rpar(76))   

      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call pdf_BT(x1, x2, pdfbt)

*
****  Q Qbar and Q .NE. UP or CHARM 
       DU1 = 0.d0
       DC1 = 0.d0
*
       iq1 =  1  
       iq2 = -1
      if(mid(11,1).ge.0) then  !  t -> UP gluon
        iq3 = -2 
        ncl = 1
        call tfcnc_01dd(iq1, iq2, iq3, id1, p1, p2, p3, p4, DU1, HR)
        idf(ncl) = 3 ! id1
        ved(ncl) = du1
         do J = 1,4
          hrd(ncl,J) = hr(j)
         enddo
      endif 
      if(mid(12,1).ge.0) then 
        iq3 = -4
        ncl = 2
        call tfcnc_01dd(iq1, iq2, iq3, id1, p1, p2, p3, p4, DC1, hr)
         idf(ncl) = 3 ! id1
         ved(ncl) = DC1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      endif
*
      do I = 1, 3
        J = 2*I - 1
        xcs( j,-j) = (DU1 + DC1) * (BRS(1,1) + BRS(2,1)) ! T + Tbar
        xcs(-j, j) = (DU1 + DC1) * (BRS(1,1) + BRS(2,1)) ! T + Tbar
       enddo
*      goto 99
*** U Ubar or C Cbar
      uu1 = 0.d0
      uu2 = 0.d0
      CC1 = 0.d0
      cc2 = 0.d0
      if(mid(11,1).ge.0) then 
       iq1 =  2
       iq2 = -2
       iq3 = -2 
       ncl = 3
       call   tfcnc_01uu(iq1, iq2, iq3, id1, p1, p2, p3, p4, UU1, hr)
           if(pyr(0).ge.0.5d0) then
            idf(ncl) = 3 
           else
            idf(ncl) = 1
           endif  
         ved(ncl) = UU1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
*
        ncl = 4
        call  tfcnc_01uu  (iq1, iq2, iq3, id1, p2, p1, p3, p4, UU2, hr)
           if(pyr(0).ge.0.5d0) then
            idf(ncl) = 3 
           else
            idf(ncl) = 1
           endif  

         ved(ncl) = UU2
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      EndIf
      If(mid(12,1).ge.0) then  
       iq1 =  4
       iq2 = -4
       iq3 = -4 
        ncl = 5
        call tfcnc_01uu(iq1,iq2,iq3, id1, p1, p2, p3,p4, CC1, hr) 
           if(pyr(0).ge.0.5d0) then
            idf(ncl) = 3 
           else
            idf(ncl) = 1
           endif  
         ved(ncl) = CC1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
        ncl = 6
        call tfcnc_01uu(iq1,iq2,iq3, id1, p2, p1, p3,p4, CC2, hr) 
           if(pyr(0).ge.0.5d0) then
            idf(ncl) = 3 
           else
            idf(ncl) = 1
           endif  

         ved(ncl) = CC2
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      endif
* (U/C)1  (U/C)2bar -> TOP 
        xcs( 2,-2) = (UU1 + DC1) * BRS(1,1)    ! T       U U~ -> T
     &             + (UU2 + DC1) * BRS(2,1)    ! Tbar    U U~ -> Tbar
*
        xcs( 4,-4) = (CC1 + DU1) * BRS(1,1)    ! T 
     &             + (CC2 + DU1) * BRS(2,1)    ! Tbar
* U1bar U2
        xcs(-2, 2) = (UU2 + DC1) * BRS(1,1)    ! T 
     &             + (UU1 + DC1) * BRS(2,1)    ! Tbar
*
        xcs(-4, 4) = (CC2 + DU1) * BRS(1,1)    ! T 
     &             + (CC1 + DU1) * BRS(2,1)    ! Tbar

****  U U 
      UU1 = 0.d0
      CC1 = 0.d0
        do j = 1,4
         pq1(j) =  p2(j)
         pq2(j) = -p3(j)
         pq3(j) = -p1(j) 
        enddo
         pq2(5) = p3(5)
         pq3(5) = p1(5)
      if(mid(11,1).ge.0) then  !  t -> UP gluon
      iq1 =  2
      iq2 =  2
      iq3 =  2 
       ncl = 7
       call tfcnc_01uu(iq1, iq2, iq3, id1, pq1, pq2, pq3, p4, UU1, hr)
           if(pyr(0).ge.0.5d0) then
            idf(ncl) = 1 
           else
            idf(ncl) = 2
           endif  
         ved(ncl) = UU1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
       xcs( 2, 2) = UU1 * BRS(1,1) ! T
       xcs(-2,-2) = UU1 * BRS(2,1) ! Tbar
      endif
      if(mid(12,1).ge.0) then  !  t -> CHARM gluon
      iq1 =  4
      iq2 =  4
      iq3 =  4 
       ncl = 8
       call tfcnc_01uu(iq1, iq2, iq3, id1, pq1, pq2, pq3, p4, UU1, hr)
           if(pyr(0).ge.0.5d0) then
            idf(ncl) = 1
           else
            idf(ncl) = 2
           endif  
         ved(ncl) = UU1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
       xcs( 4, 4) = UU1 * BRS(1,1) ! T
       xcs(-4,-4) = UU1 * BRS(2,1) ! Tbar
      endif
**** U Sbar
      uu1 = 0.d0
      uu2 = 0.d0
      CC1 = 0.d0
      CC2 = 0.d0

        do j = 1,4
         pq1(j) = -p3(j)
         pq2(j) =  p2(j)
         pq3(j) = -p1(j) 
        enddo
      If(mid(11,1).ge.0) then  !  t -> UP gluon
      iq1 =  2  
      iq2 = -1
      iq3 = -1 
        ncl = 9

        call tfcnc_01dd(iq1, iq2, iq3, id1, pq1, pq2, pq3, p4, UU1, hr)
         idf(ncl) = 1 ! id1
         ved(ncl) = UU1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
        ncl = 10
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq2, pq1, pq3, p4, UU2, hr)
         idf(ncl) = 2 ! id1
         ved(ncl) = UU2
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      EndIf
      If(mid(12,1).ge.0) then
        iq1 = 4
        ncl = 11
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq1, pq2, pq3, p4, CC1, hr)
         idf(ncl) = 1 ! id1
         ved(ncl) = CC1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
        ncl = 12
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq2, pq1, pq3, p4, CC2, hr)
         idf(ncl) = 2 ! id1
         ved(ncl) = CC2
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      EndIf
*
       xcs( 2,-4) = UU1* BRS(1,1) + CC2 * BRS(2,1) ! T + Tbar
       xcs(-2, 4) = UU1* BRS(2,1) + CC2 * BRS(1,1) ! T + Tbar
*
       xcs( 4,-2) = UU2* BRS(2,1) + CC1 * BRS(1,1) ! T + Tbar
       xcs(-4, 2) = UU2* BRS(1,1) + CC1 * BRS(2,1) ! T + Tbar
**** U/C d, s, b
      do I = 1,3
        J = 2*I - 1
           xcs( 2,-J) = UU1 * BRS(1,1) ! T
           xcs(-2, J) = UU1 * BRS(2,1) ! Tbar
           xcs(-J, 2) = UU2 * BRS(1,1) ! T
           xcs( J,-2) = UU2 * BRS(2,1) ! Tbar
*
           xcs( 4,-J) = CC1 * BRS(1,1) ! T
           xcs(-4, J) = CC1 * BRS(2,1) ! Tbar
           xcs(-J, 4) = CC2 * BRS(1,1) ! T
           xcs( J,-4) = CC2 * BRS(2,1) ! Tbar
      enddo
*
**** U S
      uu1 = 0.d0
      uu2 = 0.d0
      CC1 = 0.d0
      CC2 = 0.d0

        do j = 1,4
         pq1(j) =  p2(j)
         pq2(j) = -p3(j)
         pq3(j) = -p1(j) 
        enddo
      If(mid(11,1).ge.0) then  !  t -> UP gluon
      iq1 =  2  
      iq2 =  1
      iq3 =  1 
        ncl = 13
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq1, pq2, pq3, p4, UU1, hr)
         idf(ncl) = 1 ! id1
         ved(ncl) = UU1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
        ncl = 14
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq2, pq1, pq3, p4, UU2, hr)
         idf(ncl) = 2 ! id1
         ved(ncl) = UU2
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      EndIf
      If(mid(12,1).ge.0) then
        iq1 = 4
        ncl = 15
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq1, pq2, pq3, p4, CC1, hr)
         idf(ncl) = 1 ! id1
         ved(ncl) = CC1
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
        ncl = 16
        call tfcnc_01dd(iq1, iq2, iq3, id1, pq2, pq1, pq3, p4, CC2, hr)
         idf(ncl) = 2 ! id1
         ved(ncl) = CC2
          do J = 1,4
           hrd(ncl,J) = hr(j)
          enddo
      EndIf
*
       xcs( 2, 4) = (UU1 + CC2) * BRS(1,1) ! T
       xcs(-2,-4) = (UU1 + CC2) * BRS(2,1) ! T
*
       xcs( 4, 2) = (UU2 + CC1) * BRS(1,1) ! T
       xcs(-4,-2) = (UU2 + CC1) * BRS(2,1) ! T
*
**** U/C d, s, b
       do I = 1,3
        J = 2*I - 1
           xcs( 2, J) = UU1 * BRS(1,1) ! T
           xcs(-2,-J) = UU1 * BRS(2,1) ! Tbar
           xcs( J, 2) = UU2 * BRS(1,1) ! T
           xcs(-J,-2) = UU2 * BRS(2,1) ! Tbar
*
           xcs( 4, J) = CC1 * BRS(1,1) ! T
           xcs(-4,-J) = CC1 * BRS(2,1) ! Tbar
           xcs( J, 4) = CC2 * BRS(1,1) ! T
           xcs(-J,-4) = CC2 * BRS(2,1) ! Tbar
       enddo
*
*       do I = -5,5
*       do j = -5,5
*        if((i.eq.2.and.j.eq.2).or.(i.eq.-2.and.j.eq.-2)) then
*         xcs(i,j) = xcs(i,j)
*        else
*         xcs(i,j) = 0.d0
*        endif
*       enddo
*       enddo
       
***
 99   continue
      do i = -5,5
        do j=-5,5
         xcs(i,j) = xcs(i,j) * ves * pdfBT(i,j)
        enddo
      enddo
****
       nfp = 4
        call TXTQ1SMR(QQ, p4, p3, pft, pfq)
       do i = 1, 5
        pus(1,i) =  p1(i)
        pus(2,i) =  p2(i)
        pus(3,i) =  pfq(i) ! final quark
        pus(4,i) =  pft(i) ! final T/Tbar
       enddo
      return
      end
