*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  06.06.2006                                  *
* TopReX code = 15,  g g -> T q, fcnc, gluon                                 *
*............................................................................*
      subroutine gejzer_32(NFP) 
      Implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision p1(5),p2(5), p3(5), p4(5), pft(5),pfq(5),qq(5)
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs, PT
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision Ves, vlum, VUG, VCG 
      double precision pdfBT(-5:5, -5:5)
      integer i, j, iq3, id1, id2,j8,j9 
      double precision HR1(4), hr2(4), aran, pyr
      integer           kft, kfq, idia
      common /tplFC_GG/ kft, kfq, idia
      double precision hv
      common /topol1/  hV(4)    ! TOP polarisation vector
      save /tplfc_GG/, /topol1/
*.......
      double precision Parl(3) !, TopMV
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      integer imatch
      common /wmtch/imatch 
*
      if(first) THEN
       first=.FALSE.
        if(mid(11,1).eq.-1.AND.mid(12,1).eq.-1) then 
         print*,' '
         print*,'TopReX  FCNC process  ',ipar(1)
         print*,' FCNC (top -> !UP+CHARM! gluon) is switched OFF'
         print*,' stop TopReX run '
         STOP
         return
        endif 
        If(txsel.eq.2)  then
            Rpar(81) = Rpar(68) ! PTmin for q
        Else
            Rpar(81) = Rpar(103) ! PTmin for q
        EndIf 
         if(rpar(81).le.1.d0) rpar(81) = 1.d0
         print*,'TopReX process ',Ipar(1),' PTmin ',Rpar(81)
      ENDIF
*
      imatch = 2

      sigrx=0.d0
      do j8 = -6,6
      do j9 = -6,6
       XCS(j8,j9) = 0.d0
      enddo
      enddo
      call zer5mom(p1) 
      call zer5mom(p2) 

*
       p4(5) = mq(6)
       p3(5) = 0.d0
       Parl(1) = p3(5) + p4(5) 
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)
 100   call X1X2GEN( Parl, X1, X2, Vlum, p1, p2, QQ)
      
      call mass2(p1, p2, sg, sgs)
      Call LIPS2(QQ, P3, P4, ves)
       if(PT(p3).lt.Rpar(81)) then
          NXev(Ipar(1)) = NXev(ipar(1)) + 1
          goto 100
       endif

      Ves = Vlum * Ves * pi2_4 / (2.* sg)
      Rpar(76) = p4(1)**2 + p4(2)**2     ! pt(top)
      Rpar(75) = dsqrt(Rpar(76))   

      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call pdf_BT(x1, x2, pdfbt)
*
      if(mid(11,1).ge.0) then  !  t -> UP gluon
        iq3 = -2 
        call tfcnc_02( iq3, id1, p1, p2, p3, p4, VUG, hr1)
      endif
      if(mid(12,1).ge.0) then
        iq3 = -4
        call tfcnc_02(iq3, id2, p1, p2, p3, p4, VCG, hr2)
      endif
*
      xcs(0,0) =            VUG * (BRS(1,1) + BRS(2,1))
      xcs(0,0) = xcs(0,0) + VCG * (BRS(1,1) + BRS(2,1)) ! T + Tbar
      xcs(0,0) = xcs(0,0) * ves * pdfBT(0,0)

      aran = pyr(0)*(BRS(1,1) + BRS(2,1))
      kft = -1
      if(aran.le.BRS(1,1)) kft = +1

      If(mid(11,1).ge.0.AND.mid(12,1).ge.0) then  ! UP * CHARM
       aran = pyr(0)*(VUG + VCG) 
        if(aran.le.VUG) then ! UP
         kfq = kft * (-2) 
         idia = id1            
           do J = 1,4
            hv(J) = hr1(j)
           enddo
        else
         kfq = kft * (-4) 
         idia = id2   
          do J = 1,4
           hv(J) = hr2(j)
          enddo
        endif
      ElseIf(mid(11,1).ge.0.AND.mid(12,1).eq.-1) then  ! UP 
         kfq = kft * (-2) 
         idia = id1            
           do J = 1,4
            hv(J) = hr1(j)
           enddo
      ElseIf(mid(11,1).eq.-1.AND.mid(12,1).ge.0) then  ! CHARM
         kfq = kft * (-4) 
         idia = id2        
           do J = 1,4
            hv(J) = hr2(j)
           enddo
      EndIf
****
*      if(pt(p3).le.10.d0) then
*       print*,'****** second'
*       print*,'PT P3 ',pt(p3),(p3(i),i=1,5)
*      endif

      if(abs(kft).eq.1) kft = kft * 6
       nfp = 4
        call TXTQ1SMR(QQ, p4, p3, pft, pfq)
       do i = 1, 5
        pus(1,i) =  p1(i)
        pus(2,i) =  p2(i)
        pus(3,i) =  pfq(i) ! final quark
        pus(4,i) =  pft(i) ! final T/Tbar
       enddo
      return
      end
