*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.01.2002                                  *
*............................................................................*
      subroutine gejzer_zqq(coef) 
      Implicit None
      include "txpar.inc"  
      include "txpro.inc" 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision k1(5), k2(5), k3(5), k4(5), pz(5)
      double precision q1(5), q2(5), qq(5)
      common /txkin/q1, q2, QQ
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision Parl(3), vlum, Vlum0, VesR,
     & VDDbar, VDbarD, VUUbar, VUbarU, VGG, coef
      double precision pdfBT(-5:5, -5:5)
      integer I, iq1,ik1,ik3, iniq, j1,j2 
      common /kfzqq/ik1, ik3 
      double precision masstwo, pyr 
*.......
      double precision mzz, mzz2, pt
      common /mzzz/mzz,mzz2
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*..
      IF(first) THEN
       first = .false.
        write(*,910) Rpar(81),Rpar(82)
 910    format(//,'  Z QQbar: PTmin(q) = ',f8.3,' GeV',
     &  '  PTmin(Z) = ',f8.3,'GeV')
       if(rpar(81).lt.10.d0) then
        write(*,911) Rpar(81)
 911    format('   PTmin(q) = ',f8.3,' GeV is too small',/
     &         '   10 GeV is recommended',/)
       endif 
        print*,'                          '
        print*,'*************',' ZQQ production'
        call MQQLIM   !  check M(QQ)_min/max
        print*,'                          '
        call MFFLIM   !  check M(ff)_min/max
         if((Rpar(77)+Rpar(79)).ge.Rpar(1)) then
         print*,' min(QQ) + min(ff) = ',(Rpar(77)+Rpar(79)),
     &'  greater than sqrt(s) = ',rpar(1),' stop'
         STOP
         endif
        print*,'*************',' ZQQ production'
      ENDIF

        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
      call zer5mom(q1) 
      call zer5mom(q2) 
* evaluate of the top on-shell mass
       Parl(1) = Rpar(45) + 2.d0 * mq(Ipar(7)) 
       if(Rpar(80).lt.Rpar(45)) then
          Parl(1) = Rpar(79) + 2.d0 * mq(Ipar(7))
       endif
        if(Parl(1).lt.(2.d0*mq(ik1) + 2.d0*mq(ik3))) then
          Parl(1) = 2.d0*(mq(ik1) + mq(ik3)) 
        endif
        if(Parl(1).lt.(Rpar(77)+Rpar(79))) then
          Parl(1) = Rpar(77) + Rpar(79) 
        endif
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)
      q1(5) = 0.d0 
      q2(5) = 0.d0 
      NXev(ipar(1)) = NXev(ipar(1)) - 1
 295  continue
      call X1X2GEN2( Parl, X1, X2, Vlum0)   ! , q1, q2, QQ)
      NXev(ipar(1)) = NXev(ipar(1)) + 1
* check 
      if(QQ(5).lt.Parl(1).or.QQ(5).gt.PARL(2)) goto 295 
 296  continue
      call mass2(q1, q2, sg, sgs)

      call TXQscale   !  setting Q-scale for PDF( Rpar(3)) and for alpha_s  
      call pdf_BT(x1, x2, pdfbt)
 
      k1(5) =  mq(ik1)
      k2(5) =  mq(ik1)
      k3(5) =  mq(ik3)
      k4(5) =  mq(ik3)

 227   continue

      If(Ipar(22).eq.0) then
        if(pyr(0).ge.0.5) then
          iniq = 1
          call Rlip42(QQ, k1, k2, k3, k4, pz, vesr)
          vesr = 2.d0 * vesr
        else 
          iniq = 2
          call Rlip42(QQ, k1, k2, k3, k4, pz, vesr)
          vesr = 2.d0 * vesr
        endif
      ElseIf(Ipar(22).eq.1) then
          iniq = 1
          call Rlip423(QQ, k1, k2, k3, k4, pz, vesr)
      ElseIf(Ipar(22).eq.2) then
          iniq = 2
          call Rlip42(QQ, k1, k2, k3, k4, pz, vesr)
      Else
          return
      EndIf



      if(vesr.le.0.d0) return 
      if(pt(pz).le.rpar(82)) goto 295
      if(pt(k3).le.rpar(81).OR.pt(k4).le.rpar(81)) goto 295
      if(ik1.eq.ik3) then
       if(pt(k1).le.rpar(81).OR.pt(k2).le.rpar(81)) goto 295
      endif
      call mass2(k1, k2, mzz2, mzz) 
       if(masstwo(k3,k4).LT.rpar(77)) goto 295
       if(masstwo(k3,k4).GT.Rpar(78)) goto 295
       if(masstwo(k1,k2).LT.rpar(79)) goto 295
       if(masstwo(k1,k2).GT.Rpar(80)) goto 295
      Rpar(76) = (k1(1)+k2(1))**2 + (k1(2)+k2(2))**2 ! PT(Z)^2
      Rpar(75) = dsqrt(Rpar(76)) 

      Vgg = 0.d0 
      vDDbar = 0.d0
      vDbarD = 0.d0 
      vUUbar = 0.d0 
      vUbarU = 0.d0 

      vlum = vlum0 * coef * vesR * pi2_4 / (2.*sg)
*
      if(Ipar(22).eq.0.or.Ipar(22).eq.1) then  ! gg contribution
       call ZGGtoQQ(ik1, ik3, q1,q2, k1,k2,k3,k4, VGG) 
      endif 

      if(Ipar(22).eq.0.or.Ipar(22).eq.2) then  ! q qbar contribution
        iq1 = 1
       call ZqqtoQQ(iq1,ik1,ik3, q1,q2, k1,k2,k3,k4, vDDbar) ! d    dbar
       call ZqqtoQQ(iq1,ik1,ik3, q2,q1, k1,k2,k3,k4, vDbarD) ! dbar d
        iq1 = 2
       call ZqqtoQQ(iq1,ik1,ik3, q1,q2, k1,k2,k3,k4, vUUbar) ! U    Ubar
       call ZqqtoQQ(iq1,ik1,ik3, q2,q1, k1,k2,k3,k4, vUbarU) ! Ubar U
      endif

      xcs( 0, 0) = Vlum * VGG    * pdfBT( 0,0) 
      xcs( 1,-1) = Vlum * VDDbar * pdfBT( 1,-1) 
      xcs(-1, 1) = Vlum * VDbarD * pdfBT(-1, 1) 
      xcs( 3,-3) = Vlum * VDDbar * pdfBT( 3,-5) 
      xcs(-3, 3) = Vlum * VDbarD * pdfBT(-3, 3) 
      xcs( 5,-5) = Vlum * VDDbar * pdfBT( 3,-5) 
      xcs(-5, 5) = Vlum * VDbarD * pdfBT(-5, 5) 

      xcs( 2,-2) = Vlum * VUUbar * pdfBT( 2,-2) 
      xcs(-2, 2) = Vlum * VUbarU * pdfBT(-2, 2) 
      xcs( 4,-4) = Vlum * VUUbar * pdfBT( 4,-4) 
      xcs(-4, 4) = Vlum * VUbarU * pdfBT(-4, 4) 
***
        do i=1,5
          pus(1,i) = q1(i)
          pus(2,i) = q2(i)
          pus(3,i) = pz(i) 
          pus(4,i) = k1(i)
          pus(5,i) = k2(i) 
          pus(6,i) = k3(i) 
          pus(7,i) = k4(i) 
        enddo
          pus(3,5)=dsqrt(pz(4)**2-pz(1)**2-pz(2)**2-pz(3)**2) 

      return
      end
