*----------------------------------------------------------------------------*
*..Rpar(57)     : neutral Higgs (SM) mass                                    *
*..Rpar(58)     : total Higgs decay width                                    *
*..Rpar(59)     : M(H) * Width(H)                                            *
*                                                                            *
      subroutine H0_dec_ini
*     ---------------------
      implicit none
      include "txpar.inc" 
      double precision GAM(3)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision G2, GF, mh, mh2, mz, mz2, mw,mw2 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
*      COMMON/INFO/EMW,EMW2,EMZ,EMZ2,EMH,EMH2,GH,XW,AL,ALZ,ALS
*      COMMON/QUARK/EM2(5),EC2(5,2),NQ
C 1=ZZ ; 2=WW ; 3=TT
      
      INTEGER         KCHG 
      DOUBLE PRECISION            PMAS,       PARF,      VCKM
      COMMON /PYDAT2/ KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)



*      XW= Rpar(23) ! sinT**2 0.23D0
*      AL= Rpar(11) ! 1.D0/128.D0
      G2 = 4.d0 * pi * Rpar(11) / Rpar(23) !      G2=4.*PI*AL/XW
      GF = G2/PI/16.d0
      mh = Rpar(57)
      mh2 = mh**2
      mz = Rpar(45)
      mz2 = mz**2
      mw = Rpar(41)
      mw2 = mw**2
C
      IF (MH .LE. (2.d0*MZ)) THEN
       GAM(1)=0.0d0
      ELSE
       GAM(1)=GF/MH*DSQRT(1.-4.*MZ2/MH2)*MZ2/rpar(24)/2.d0
     & * (3.d0-MH2/MZ2+(MH2/MZ2)**2/4.d0)
*       GAM(1)=GF/MH*DSQRT(1.-4.*MZ2/MH2)*MZ2/rpar(24)(1.D0-XW)/2.*(3.-EMH2
*     1  /EMZ2+(EMH2/EMZ2)**2/4.)
      ENDIF
C
      IF (MH .LE. (2.0*MW)) THEN
       GAM(2)=0.
      ELSE
       GAM(2)=GF/MH*DSQRT(1.-4.*MW2/MH2)*MW2
     & *(3.d0-MH2/MW2 + (MH2/MW2)**2/4.d0)
      ENDIF
C
      IF (MH .LE. (2.d0*mq(6))) THEN
       GAM(3)=0.0
      ELSE
       GAM(3)=GF/MH*DSQRT(1.-4.*mq2(6)/MH2)*(MH2-4.*mq2(6))
     & * mq2(6) /MW2/2.*3.
      ENDIF
C
      if((GAM(1)+GAM(2)+GAM(3)).gt.Rpar(58)) then
        Rpar(58) = GAM(1)+GAM(2)+GAM(3)
      endif
      Rpar(59) = Rpar(57) * Rpar(58) 
      write(*, 71)
 71   format(/,'   TopReX : Neutral Higgs parameters ',/
     &,        '   ----------------------------------')
       write(*, 172) Rpar(57),gam(1),gam(2),gam(3),Rpar(58)
 172  format(2x,'m(Higgs) = ',1p,d10.3,/,
     &2x,'Wid(H -> Z Z)  = ',1p,d10.3,/
     &2x,'Wid(H -> W+W-) = ',1p,d10.3,/
     &2x,'Wid(H -> T T~) = ',1p,d10.3,/,
     &2x,'Width(total)   = ',1p,d10.3,/)
      write(*, 173) pmas(25,1),pmas(25,2)
 173  format(2x,'m(Higgs) = ',1p,d10.3,/,
     &2x,'Width(total)   = ',1p,d10.3,/)
      RETURN
      END
