*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   10.09.2002                                 *
*.... H+- decay into t* (-> b W* => b f1 f2) + bbar                          *
      subroutine HPM_dec_11(ih, kfh) 
*     -----------------------------------------------                        *
*   H(ph) -> b(k1) t*(p) W*(q) nu(l1) l+-(l2) bbar(q1)                       *
*............................................................................*

      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      double precision CKM2
      common /CKMD/    CKM2(-6:6,-6:6)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)

      double precision PH(5), L1(5), L2(5), K1(5), q1(5)
      double precision Ves 
      double precision PYR
*...........
      LOGICAL first
      SAVE first 
      DATA first /.TRUE./
      double precision VesMaX(30), aran, dh(3), coef 

      save VesMaX, coef 
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer I, II, ih, kfh, irw, idw, iz, kv, il1, il2 
      double precision vh      
      common /topol1/ vh(4)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 

       do I = 1,5
        ph(I) = pup(I, ih)
       enddo
      ndec = 6
      if(.NOT.first) goto 114 
        do I = 1,30
         vesmax(i) = 0.d0
        enddo
      coef = pi2_4 / 2.d0 
      do 225 i = 1, mid(0,2)
       if(mid(i,2).le.-1) goto 225
        do ii = 1, ipar(53)
         call HPM_ME_03(i, ph, k1, q1, l1, l2, dh, ves) 
         ves = ves * coef / ph(5)
         if(vesmax(i).le.ves) vesmax(i) = ves
        enddo 
 225  continue
      first = .false. 
 114  continue
       irw  = 2       ! W+-
       call Res_branch (IRW, kfh, idw) 
         call HPM_ME_03(idw, ph, k1, q1, l1, l2, dh, ves) 
         ves = ves * coef / ph(5)
         if(vesmax(i).le.ves) vesmax(i) = ves
         aran = VesMax(idw) * PYR(0) 
         if(Ves.lt.aran) goto 114 
* color flow
        iz =  kfh / abs(kfh)  ! +1(-1) for top (topbar) 
        kv  = iz * 37       ! KF code of H-boson from top 
        il1 = FID(2,idw,1) 
        il2 = FID(2,idw,2) 
      kdec(1,1) = -5 * iz   ! bbar
      kdec(2,1) =  6 * iz   ! t*
      kdec(3,1) =  5 * iz   ! b from t*
      kdec(4,1) = 24 * iz   ! W
      kdec(5,1) = il1 * iz 
      kdec(6,1) = il2 * iz

      do I = 1,5
       pdm(1,I) = q1(I)                 ! bbar
       pdm(2,i) = k1(I) + L1(I) + L2(I) ! t*
       pdm(3,I) = k1(I)                 ! b from t*
       pdm(4,I) = L1(I) + L2(I)         ! W
       pdm(5,I) = L1(I) 
       pdm(6,I) = L2(I) 
      enddo
       pdm(2,5) = dsqrt(pdm(2,4)**2 - pdm(2,1)**2
     &                 - pdm(2,2)**2 - pdm(2,3)**2)
       pdm(4,5) = dsqrt(pdm(4,4)**2 - pdm(4,1)**2
     &                 - pdm(4,2)**2 - pdm(4,3)**2)
      do I = 1,3
       pdm(20,I) = dh(I)
      enddo
      return
      end
