*----------------------------------------------------------------------------*
      subroutine HPM_ME_03(id, ph, k, q, l1, l2, dh, ves) 
*     -------------------------------                                        *
*                                                                            *
*   H+ -> Bbar(q) T*(p), T* -> B(k) W*, W* -> nu,U(l1), tau,Dbar(L2)         *
*   color are includes                                                       *
*   is normalized to the TOTAL top-quark decay width                         *
*............................................................................*

      implicit none

      include "txpar.inc" 
      double precision CKM2
      common /CKMD/    CKM2(-6:6,-6:6)

      double precision p(5), k(5), q(5), l1(5), l2(5), ves, scalp 
      double precision mhs, ph(5)
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
*...........
      integer il1, il2, j, id 
      double precision r(5), pw(5), f1(5), f2(5), f3(5), dh(3) 
      double precision lv(4), vh(3,4) 
      double precision coef, AA1(4), AA2(4), AA3(4) 
      double precision p22, pq, rl1, rk, pwr, pwk, pwl1, pw22,l1k 
      double precision pmm(2), vs1, p2s, vem
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 
       dh(1) = 0.d0
       dh(2) = 0.d0
       dh(3) = 0.d0
      ves = 0.d0

      mhs = ph(5) 
*      coef = pi2_4 / 2.d0 / mhs 
      coef =  pi2_6 
      coef = coef * (3.d0/2.d0) * rpar(26)**6
      
      K(5) = mq(5) 
      q(5) = mq(5) ! bbar

       il1 = FID(2,id,1) 
       il2 = FID(2,id,2) 
      if(abs(il1).eq.6) return

        l1(5) = mq(abs(il1))        
        l2(5) = mq(abs(il2))        
      pmm(1) = rpar(70) + mq(5)
      pmm(2) = mhs - mq(5)
      call brtwig(pmm, mq(6), rpar(36), VS1, p2s)
       ves = coef * VS1 
       p(5) = p2s
      pmm(1) = rpar(70)
      pmm(2) = p(5) - mq(5)
      call brtwig(pmm, rpar(41), rpar(44), VS1, p2s)
       pw(5) = p2s
       ves = ves * VS1 
      call LIPS2 (ph, q, p,  VS1) 
      ves = ves * VS1 
      call LIPS2 (p,  k, pw,  VS1) 
      ves = ves * VS1 
      call LIPS2 (pw,  l1, l2, VS1) 
      ves = ves * VS1 
*
      p22 = scalp(p, p) 
      pq  = scalp(p, q)

      do j = 1,4
       r(j) = (hcpl2(6)*mq2(6)-hcpl2(5)*p22) * q(j)
     &      + 2.d0 * hcpl2(5)* pq * p(j)
     &      - 2.d0*mq(5)*mq(6)*hcpl(5)*hcpl(6)*p(j)
      enddo

      rl1 = scalp(r, l1) 
      rk  = scalp(r, k)
      pwr = scalp(pw, r) 
      pwk = scalp(pw, k) 
      pwl1= scalp(pw, l1)
      pw22= scalp(pw, pw) 
      l1k = scalp(l1, k)

      do j = 1,4
       f1(j) = rl1* pw(j) + pwl1 * r(j) - pwr * l1(j)
       f2(j) = rk * pw(j) + pwk  * r(j) - pwr * k(j) 
       f3(j) = rk * l1(j) + l1k  * r(j) - rl1 * k(j) 
      enddo

      AA1(1) = 4.d0 * l1k * scalp(r, l2)

      AA2(1) = 4.d0 *pwk  * scalp(l2, f1)
     &       - 4.d0 *pwl1 * scalp(l2, f2)
     &       + 2.d0 *pw22 * scalp(l2, f3)

      AA3(1) = (mq2(abs(il1))+mq2(abs(il2)))*scalp(l1,l2)
     &      * (2.d0*pwk*pwr - pw22 * rk)

      VEM = AA1(1) - AA2(1) / rpar(42) + AA3(1) / rpar(42)**2

      if(abs(il2).ne.15) goto 221 
*
      do J = 1,4
       AA1(j) = 4.d0 * l1k  * r(j) 
       AA2(j) = 4.d0 * pwk  * f1(j)
     &        - 4.d0 * pwl1 * f2(j) 
     &        + 2.d0 * pw22 * f3(j) 
       AA3(j) = (2.d0*pwk*pwr - pw22 * rk)
     &        * (-mq2(15)) * l1(j)

      lv(j) = -( mq(15) / vem) 
     & * (AA1(j) - AA2(j)/rpar(42) + AA3(j)/rpar(42)**2)
      if(il2.eq.15) lv(j) = -lv(j)
      enddo

      call vortas(l2, vh)
       do j = 1,3
        dh(j) = -(lv(4)*vh(j,4) - lv(1)*vh(j,1) - lv(2)*vh(j,2) 
     &                          - lv(3)*vh(j,3))
       enddo

 221  ves = vem  * ves
       if(abs(il1).le.6) ves = ves * 3.d0 * ckm2(il1,il2)

      RETURN
      END
