*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   10.03.2002                                 *
*.... H+- decay into t* (-> b W* => b f1 f2) + bbar                          *
*   is normalized to the TOTAL top-quark decay width                         *
      subroutine HTB_dec(gtot) 
*     ------------------------                                               *
*   H(ph) -> Bbar(q1) t*(p)(-> b(k1) W*(pw)(-> nu(l2) l+-(l1)))              *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      double precision CKM2
      common /CKMD/    CKM2(-6:6,-6:6)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
*...........
      double precision  L1(5), L2(5), K1(5), q1(5) 
      double precision Ves, gtot, dh(3), mhs, ph(5), coef
      integer id,ii  
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 
        Gtot = 0.d0
      coef = pi2_4 / 2.d0 
   
      mhs = rpar(51) 
      ph(5) = mhs
      ph(4) = ph(5)
      do 225 id = 1,mid(0, 2) 
       if(mid(ID, 2).le.-1) goto 225
      DO ii = 1, ipar(53)
       call HPM_ME_03(id, ph, k1, q1, l1, l2, dh, ves) 
       ves = ves * coef / mhs
      Gtot = Gtot + ves 
      ENDDO
 225  continue
      Gtot = Gtot / ipar(53) 

      return
      end
