c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  20.11.2004                                  *
*   M(q qbar) min/max for  W/Z Q Qbar production                             *
*............................................................................*
      subroutine MQQLIM
      implicit None
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer LD, LU
*
      Ld = 1
*     
      if(Rpar(77).eq.-1.d0) then
         Rpar(77) = 2.*mq(Ipar(7)) ! default 
         Ld = 0
      elseif(Rpar(77).lt.(2.*mq(Ipar(7))).OR.
     &       Rpar(77).ge.Rpar(1)) then
         Ld = -1
          print*,' user value of min(M(QQ))',rpar(77),
     &' is outside kinematic limits - stop'           
         STOP
      endif 
*  check max M(QQ)
      Lu = 1
      if(Rpar(78).eq.-1.d0) then
         Lu = 0
         Rpar(78) = Rpar(1)  ! default
      elseif(Rpar(78).ge.Rpar(1)) then
         Lu = 0
        print*,' M(QQ)-max ',rpar(78),
     &' is greater then sqrt(s). Value from LIPS will be used'
          Rpar(78) = Rpar(1)
      elseif(Rpar(78).gt.0.d0.AND.Rpar(78).le.rpar(77)) then
        Lu = -1 
        print*,' M(QQ)-max',rpar(78),
     &' less then M(QQ)-min ',rpar(77),' stop'           
           STOP
       endif
**
       if(Ld.eq.0) then 
        print*,' default M(QQ)-min = 2M(Q) = ',rpar(77)
       elseif(Ld.eq.1) then 
         print*,' M(QQ)-min = ',rpar(77)
       else
        STOP
       endif
       if(Lu.eq.0)  then
         print*,' M(QQ)-max from LIPS'
       elseif(Lu.eq.1) then
         print*,' M(QQ)-max = ',rpar(78)
       else
        STOP
       endif
      RETURN
      end
