*----------------------------------------------------------------------------*
* FCNC vertex  :  q - gluon gamma - top                                      *
* iu FCNC-q-type (1-u, 2-t), q - gluon momentum (ON and OFF shell), k - quark* 
* FINAL TOP quark,                                                           *
* PG and EG are incoming gluon  momentum and polarization vector             *
* PF and EF are incoming photon momentum and polarization vector             *
* 2/3 in NOT included                                                        *
* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
      subroutine Q_GLU_GAM_T(iu, pg, pf, eg, ef, VRT)
*     ----------------------------------------------
      implicit none
      double precision pg(5), pf(5), eg(5), ef(5), scalp, u1, u2
      double complex   C_HR,   C_HL,   C_XR,   C_TR,   C_XL,   C_TL
      common /ruiped2/ C_HR(2),C_HL(2),C_XR(2),C_TR(2),C_XL(2),C_TL(2)
      integer IU, j8,j9 
      double complex VRT(4,4), M1(4,4), hpg(4,4), hef(4,4)
*
      do j8 = 1,4
      do j9 = 1,4
        VRT(j8,j9) = (0.d0, 0.d0)
      enddo
      enddo
*
      call phat(pg, hpg)
      call phat(ef, hef)
*
      u1 = -scalp(eg, ef)
      u2 = +scalp(pg, ef)
*
      call matr_add_RR(u1, hpg, u2, hef, m1)
      call matr_A_FRL(C_XR(iu), C_XL(iu), m1, VRT) 
*
      return
      end
