*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  01/06/2006                                  *
* TopReX code = 14,  q q -> T q, fcnc, gluon                                 *
*............................................................................*
      subroutine razbor_14(ip1, ip2, kft, kfm, kf3) 
      Implicit None
      include "txpar.inc" 
      double precision aran, PYR, S1,s2
      integer j, ip1, ip2, kft, kf3, kcl, kfm
      integer       idum,     idf 
      double precision                 ved,     HRD 
      common /tplFC/idum(16), idf(16), ved(16), HRD(16,4)
      double precision hv 
      common /topol1/ hv(4)    ! TOP lepton polarisation vector
*.......
*      integer        PID(20) 
*      common /TXtopcpl/ PID      ! 1/0 = ON/OFF top interaction 
*****************
      kft = 0
      kfm = 0
      kcl = 0
      kf3 = 0
*
*      print*,'**********************'
*      do J = 1,16
*       print*,' J ves ',j,ved(j)
*      enddo
      IF(ip1.eq.(-ip2).AND.abs(ip1).ne.2.AND.abs(ip1).ne.4) then
****  Q Qbar and Q .NE. UP or CHARM 
*
* DU1 = VED(1),  DC1 = VED(2)
* KF top, position of top, KF of final quark, polarization number in HRD array
* kft     kfm              kf3                kcl
*
        KFT = +1
        aran = pyr(0)*(BRS(1,1) + BRS(2,1)) 
        if(aran.gt.BRS(1,1)) KFT = -1  ! KF top
      if(mid(11,1).ge.0.AND.mid(12,1).ge.0) then  !  both UP and CHARM
          KF3 = kft * (-2)
          KCL = 1  ! number of top polarization in HRD array
         aran = pyr(0)*(ved(1) + ved(2)) ! DU1 = VED(1),  DC1 = VED(2) 
         if(aran.gt.ved(1)) then
          KF3 = kft * (-4)
          KCL = 2
         endif
      elseif(mid(11,1).ge.0.AND.mid(12,1).eq.-1) then  ! only UP
         KF3 = kft * (-2)
         KCL = 1
      elseif(mid(11,1).eq.-1.AND.mid(12,1).ge.0) then  ! only CHARM
         KF3 = kft * (-4)
         KCL = 2
      endif
         kfm = 3     ! position of top mother     
*** U Ubar or C Cbar
      ELSEIF(ip1.eq.2.AND.ip2.eq.-2) then
* ved(1) = DU1, ved(2) = DC1 
* ved(3) = UU1, ved(4) = UU2, ved(5) = CC1, ved(6) = CC2
* idf(3)= iuu1, idf(4)= iuu2, idf(5)= icc1, idf(6)= icc2
* (U/C)1  (U/C)2bar -> TOP
        s1 = (ved(3) + ved(2)) * BRS(1,1) ! T       U U~ -> T
        s2 = (ved(4) + ved(2)) * BRS(2,1) ! Tbar    U U~ -> Tbar
*  xcs( 2,-2) = s1 + s2        ! T + Tbar
         If((pyr(0)*(s1+s2)).le.s1) then
          kft = +6
           if((pyr(0)*(ved(3)+ved(2))).le.ved(3)) then
             kf3 = -2
             kfm = idf(3)
             kcl = 3
           else
             kf3 = -4
             kfm = 3
             kcl = 2
           endif
         Else
          kft = -6
           if((pyr(0)*(ved(4)+ved(2))).le.ved(4)) then
             kf3 = 2
             kfm = idf(4)
             kcl = 4 
             if(kfm.le.2) kfm = 3 - kfm ! 
           else
             kf3 = 4
             kfm = 3
             kcl = 2 
           endif
         EndIf 
      ELSEIF(ip1.eq.4.AND.ip2.eq.-4) then
* ved(1) = DU1, ved(2) = DC1 
* ved(3) = UU1, ved(4) = UU2, ved(5) = CC1, ved(6) = CC2
* idf(3)= iuu1, idf(4)= iuu2, idf(5)= icc1, idf(6)= icc2
** (U/C)1  (U/C)2bar -> TOP

        s1 = (ved(5) + ved(1)) * BRS(1,1) ! T 
        s2 = (ved(6) + ved(1)) * BRS(2,1) ! Tbar
*  xcs( 4,-4) = s1 + s2 ! T + Tbar
         If((pyr(0)*(s1+s2)).le.s1) then
          kft = +6
           if((pyr(0)*(ved(5) +ved(1))).le.ved(5)) then
             kf3 = -4
             kfm = idf(5) 
             kcl = 5
           else
             kf3 = -2
             kfm = 3
             kcl = 1
           endif
         Else
          kft = -6
           if((pyr(0)*(ved(6) + ved(1))).le.ved(6)) then
             kf3 = 4
             kfm = idf(6) 
             if(kfm.le.2) kfm = 3 - kfm ! 
             kcl = 6
           else
             kf3 = 2
             kfm = 3
             kcl = 1
           endif
         EndIf 
      ELSEIF(ip1.eq.-2.AND.ip2.eq.+2) then
* ved(1) = DU1, ved(2) = DC1 
* ved(3) = UU1, ved(4) = UU2, ved(5) = CC1, ved(6) = CC2
* idf(3)= iuu1, idf(4)= iuu2, idf(5)= icc1, idf(6)= icc2
* U1bar U2
        s1 = (ved(4) + ved(2)) * BRS(1,1) ! T 
        s2 = (ved(3) + ved(2)) * BRS(2,1) ! Tbar
*  xcs(-2, 2) = s1 + s2        ! T + Tbar
         If((pyr(0)*(s1+s2)).le.s1) then
          kft = +6
           if((pyr(0)*(ved(4) + ved(2))).le.ved(4)) then
            kf3 = -2
            kfm = idf(4) 
            if(kfm.le.2) kfm = 3 - kfm ! 
            kcl = 4
           else
            kf3 = -4
            kfm = 3
            kcl = 2
           endif
         Else
          kft = -6
           if((pyr(0)*(ved(3) + ved(2))).le.ved(3)) then
            kf3 = 2
            kfm = idf(3)
            kcl = 3
           else
            kf3 = 4
            kfm = 3
            kcl = 2
           endif
         EndIf
****
      ELSEIF(ip1.eq.-4.AND.ip2.eq.+4) then
* ved(1) = DU1, ved(2) = DC1 
* ved(3) = UU1, ved(4) = UU2, ved(5) = CC1, ved(6) = CC2
* idf(3)= iuu1, idf(4)= iuu2, idf(5)= icc1, idf(6)= icc2
* U1bar U2
        s1 = (ved(6) + ved(1)) * BRS(1,1) ! T 
        s2 = (ved(5) + ved(1)) * BRS(2,1) ! Tbar
*  xcs(-4, 4) = s1 + s2 ! T + Tbar
         If((pyr(0)*(s1+s2)).le.s1) then
          kft = +6
           if((pyr(0)*(ved(6) + ved(1))).le.ved(5)) then
            kf3 = -4
            kfm = idf(6) 
            if(kfm.le.2) kfm = 3 - kfm 
            kcl = 6
           else
            kf3 = -2
            kfm = 3
            kcl = 1
           endif
         Else
          kft = -6
           if((pyr(0)*(ved(5) + ved(1))).le.ved(5)) then
            kf3 = 4
            kfm = idf(5)
            kcl = 5
           else
            kf3 = 2
            kfm = 3
            kcl = 1
           endif
         EndIf 
*************
      ELSEIF(ip1.eq.ip2.AND.ABS(ip1).eq.+2) then
* ved(7) = UU1, idf(7) = iuu1 
        kfm = idf(7)
        kcl = 7
        kf3 = ip1
         if(ip1.gt.0) kft = +6      ! KF top
         if(ip1.lt.0) kft = -6      ! KF Tbar
******
      ELSEIF(ip1.eq.ip2.AND.abs(ip1).eq.+4) then
* ved(8) = CC1, idf(8)= id1 
        kfm = idf(8)  ! position of m.t.c
        kcl = 8       ! polarization number 
        kf3 = ip1
        if(ip1.gt.0) kft = +6 
        if(ip1.lt.0) kft = -6      ! KF top
*************
      ELSEIF(ip1.eq.+2.AND.ip2.eq.-4) then
* ved(9) = UU1, ved(10) = UU2, ved(11) = CC1, ved(12) = CC2
* idf(9)= iuu1, idf(10)= iuu2, idf(11)= icc1, idf(12)= icc2
*  xcs( 2,-4) = UU1* BRS(1,1) + CC2 * BRS(2,1) ! T + Tbar
        s1 =  ved(9)*BRS(1,1)
        s2 = ved(12)*BRS(2,1)
        aran = pyr(0) * (s1 + s2)
       if(aran.le.s1) then
         kft = +6  ! Top
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  9  ! polarization 
       else
         kft = -6
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  12 ! KF code of final 3
       endif
*************
      ELSEIF(ip1.eq.-2.AND.ip2.eq.+4) then
* ved(9) = UU1, ved(10) = UU2, ved(11) = CC1, ved(12) = CC2
* idf(9)= iuu1, idf(10)= iuu2, idf(11)= icc1, idf(12)= icc2
*  xcs(-2, 4) = UU1* BRS(2,1) + CC2 * BRS(1,1) ! T + Tbar
        s1 =  ved(9)*BRS(2,1)
        s2 = ved(12)*BRS(1,1)
       aran = pyr(0) * (s1 + s2)
       if(aran.le.s1) then
         kft = -6
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  9  ! polarization 
       else
         kft = +6
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  12 ! KF code of final 3
       endif
*************
      ELSEIF(ip1.eq.+4.AND.ip2.eq.-2) then
* ved(9) = UU1, ved(10) = UU2, ved(11) = CC1, ved(12) = CC2
* idf(9)= iuu1, idf(10)= iuu2, idf(11)= icc1, idf(12)= icc2
*  xcs( 4,-2) = UU2* BRS(2,1) + CC1 * BRS(1,1) ! T + Tbar
        s1 = ved(10)*BRS(2,1)
        s2 = ved(11)*BRS(1,1)
       aran = pyr(0) * (s1 + s2)
       if(aran.le.s1) then
         kft = -6
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  10 ! polarization 
       else
         kft =  6
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  11 ! KF code of final 3
       endif
*************
      ELSEIF(ip1.eq.-4.AND.ip2.eq.+2) then
* ved(9) = UU1, ved(10) = UU2, ved(11) = CC1, ved(12) = CC2
* idf(9)= iuu1, idf(10)= iuu2, idf(11)= icc1, idf(12)= icc2
*  xcs(-4, 2) = UU2* BRS(1,1) + CC1 * BRS(2,1) ! T + Tbar
        s1 = ved(10)*BRS(1,1)
        s2 = ved(11)*BRS(2,1)
       aran = pyr(0) * (s1 + s2)
       if(aran.le.s1) then
         kft =  6
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  10 ! polarization 
       else
         kft = -6
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  11 ! KF code of final 3
       endif
*****************
      ELSEIF((ip1.eq.+2.or.ip1.eq.+4).AND.
     & (ip2.eq.-1.OR.ip2.eq.-3.or.ip2.eq.-5)) then
        kft =  6  ! KF top
        kfm =  1  ! position of m.t.c
        kf3 = ip2 ! KF code of final 3
        kcl =  9  ! KF code of final 3
*****************
      ELSEIF((ip1.eq.-2.or.ip1.eq.-4).AND.
     & (ip2.eq.+1.OR.ip2.eq.+3.or.ip2.eq.+5)) then
*   xcs(-2, J) = UU1 * BRS(2,1) ! Tbar
        kft = -6  ! KF top
        kfm =  1  ! position of m.t.c
        kf3 = ip2 ! KF code of final 3
        kcl =  9 ! KF code of final 3
*****************
      ELSEIF((ip2.eq.+2.or.ip2.eq.+4).AND.
     & (ip1.eq.-1.OR.ip1.eq.-3.or.ip1.eq.-5)) then
*  xcs(-J, 2) = UU2 * BRS(1,1) ! T
        kft =  6  ! KF top
        kfm =  2  ! position of m.t.c
        kf3 = ip1 ! KF code of final 3
        kcl = 10  ! KF code of final 3
*****************
      ELSEIF((ip2.eq.-2.or.ip2.eq.-4).AND.
     & (ip1.eq.+1.OR.ip1.eq.+3.or.ip1.eq.+5)) then
*  xcs( J,-2) = UU2 * BRS(2,1) ! Tbar
        kft = -6  ! KF top
        kfm =  2  ! position of m.t.c
        kf3 = ip1 ! KF code of final 3
        kcl = 10  ! KF code of final 3
*********


*****************
      ELSEIF( (ip1.eq.+2.AND.ip2.eq.+4).
     &     or.(ip1.eq.-2.AND.ip2.eq.-4)) then
* ved(13) = UU1, ved(14) = UU2, ved(15) = CC1, ved(16) = CC2
*   xcs( 2, 4) = (UU1 + CC2) * BRS(1,1) ! T
*   xcs(-2,-4) = (UU1 + CC2) * BRS(2,1) ! T
        if(ip1.gt.0) kft = +6
        if(ip1.lt.0) kft = -6
       aran = pyr(0) * (ved(13) + ved(16))
       if(aran.le.ved(13)) then
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  13 ! polarization 
       else
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  16 !
       endif
*****************
      ELSEIF( (ip1.eq.+4.AND.ip2.eq.+2).
     &     or.(ip1.eq.-4.AND.ip2.eq.-2)) then
* ved(13) = UU1, ved(14) = UU2, ved(15) = CC1, ved(16) = CC2
*   xcs( 4, 2) = (UU2 + CC1) * BRS(1,1) ! T
*   xcs(-4,-2) = (UU2 + CC1) * BRS(2,1) ! T
        if(ip1.gt.0) kft = +6
        if(ip1.lt.0) kft = -6
       aran = pyr(0) * (ved(14) + ved(15))
       if(aran.le.ved(14)) then
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  14 ! polarization 
       else
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  15 !
       endif
**********
      ELSEIF( 
     &(ip1.eq.+2.and.(ip2.eq.+1.OR.ip2.eq.+3.or.ip2.eq.+5))
     & .OR.
     &(ip1.eq.-2.and.(ip2.eq.-1.OR.ip2.eq.-3.or.ip2.eq.-5)) 
     &    ) then
* ved(13) = UU1, ved(14) = UU2, ved(15) = CC1, ved(16) = CC2
*    xcs( 2, J) = UU1 * BRS(1,1) ! T
*    xcs(-2,-J) = UU1 * BRS(2,1) ! Tbar
        if(ip1.gt.0) kft = +6
        if(ip1.lt.0) kft = -6
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  13 ! polarization 
**********
      ELSEIF( 
     &(ip2.eq.+2.and.(ip1.eq.+1.OR.ip1.eq.+3.or.ip1.eq.+5))
     & .OR.
     &(ip2.eq.-2.and.(ip1.eq.-1.OR.ip1.eq.-3.or.ip1.eq.-5)) 
     &    ) then
* ved(13) = UU1, ved(14) = UU2, ved(15) = CC1, ved(16) = CC2
* xcs( J, 2) = UU2 * BRS(1,1) ! T
* xcs(-J,-2) = UU2 * BRS(2,1) ! Tbar
        if(ip2.gt.0) kft = +6
        if(ip2.lt.0) kft = -6
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  14 ! polarization 
**********
      ELSEIF( 
     &(ip1.eq.+4.and.(ip2.eq.+1.OR.ip2.eq.+3.or.ip2.eq.+5))
     & .OR.
     &(ip1.eq.-4.and.(ip2.eq.-1.OR.ip2.eq.-3.or.ip2.eq.-5)) 
     &    ) then
* ved(13) = UU1, ved(14) = UU2, ved(15) = CC1, ved(16) = CC2
* xcs( 4, J) = CC1 * BRS(1,1) ! T
* xcs(-4,-J) = CC1 * BRS(2,1) ! Tbar
        if(ip1.gt.0) kft = +6
        if(ip1.lt.0) kft = -6
         kfm =  1  ! position of m.t.c
         kf3 = ip2 ! KF code of final 3
         kcl =  15 ! polarization 
**********
      ELSEIF( 
     &(ip2.eq.+4.and.(ip1.eq.+1.OR.ip1.eq.+3.or.ip1.eq.+5))
     & .OR.
     &(ip2.eq.-4.and.(ip1.eq.-1.OR.ip1.eq.-3.or.ip1.eq.-5)) 
     &    ) then
* ved(13) = UU1, ved(14) = UU2, ved(15) = CC1, ved(16) = CC2
* xcs( J, 4) = CC2 * BRS(1,1) ! T
* xcs(-J,-4) = CC2 * BRS(2,1) ! Tbar
        if(ip2.gt.0) kft = +6
        if(ip2.lt.0) kft = -6
         kfm =  2  ! position of m.t.c
         kf3 = ip1 ! KF code of final 3
         kcl =  16 ! polarization 
****
      ENDIF

      If(abs(kft).eq.1) kft = 6 * kft 
*
*      if(kft.eq.0.or.kfm.eq.0.or.kf3.eq.0.or.kcl.eq.0) then
*      print*,'********************'
*       print*,' ip1 ip2 kft kfm kf3 kcl ', ip1,ip2,kft,kfm,kf3,kcl
*      endif
      do J = 1,4
       HV(J) = HRD(kcl, J)
      enddo
      return
      end
