c----------------------------------------------------------------------------c
*  27.07.2003
* return PDF set parameters, PYTHIA 6... only

      subroutine Rep_PDF
*
      Implicit None
      INTEGER MSTP, MSTI
      double precision PARP, PARI
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
      integer i
      Character*11 IPDF, Icur
      Character*60 INAM(9)
      data INAM /
     &' = 1 : CTEQ 3L (leading order)                              ',
     &' = 2 : CTEQ 3M (MSbar)                                      ',
     &' = 3 : CTEQ 3D (DIS)                                        ',
     &' = 4 : GRV 94L (leading order)                              ',
     &' = 5 : GRV 94M (MSbar)                                      ',
     &' = 6 : GRV 94D (DIS)                                        ',
     &' = 7 : CTEQ 5L (leading order)                              ',
     &' = 8 : CTEQ 5M1 (MSbar; slightly updated version of CTEQ 5M)',
     &' = 11: GRV 92L (leading order)                              '/

      IPDF = 'Current PDF'
  
      if(MSTP(52).ne.1) return 
      write(*,4000) 
 4000 format(/,79('*'),/,
     &'  TopReX : PDF set : '/,
     &'  ------------------',/,
     &'  Current list of distributions available in PYTHIA 6...',
     &' (default is GRV 94L)',/,
     &'  In this running we use')
       do i = 1,9
        Icur = '           '
       if(MSTP(51).eq.i) Icur = IPDF
       write(*, 4001) Icur, Inam(i)
 4001  format(3x,a11,1x,a61)
       enddo
       write(*, 4002)
 4002  format(/,' Note: option 11 is only implemented to have one set',
     &'in common between',/,3x,'Pythia 5 and 6, for crosschecks',/,
     &79('*')) 

      return
      end
