*----------------------------------------------------------------------------*
      subroutine tfcnc_01dd(iq1, iq2, iq3, imt, p1, p2, p3, p4,ves,hv)
      implicit none
      include "txpar.inc" 
      double precision  p1(5), p2(5)       ! momenta of initial quarks
      double precision  p3(5), p4(5)       ! momenta of Y and top 
      double precision s,t,mt,mt2,mt4,mt6,  epsl(5)
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
      double complex alctCR, alctR, altcR, altcCR, alctCL, alctL,
     &  altcL, altcCL, betc, betcC, bectC, bect
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer iq1, iq2, iq3, imt, iqf, J
      double complex U0, U1, a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,
     & a11,a12,a13,a14,
     & b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,
     & b11,b12,b13,b14,b15,b16,b17,b0, egr
      double precision ves, coef, s2,t2, sat, mt2sm,
     & sp(4), vh(3,4), hv(4)
      double complex ei 
      data ei/(0.d0, 1.d0)/
      LOGICAL first
      SAVE first, coef, mt,mt2,mt4,mt6
      DATA first /.TRUE./
*******
      IF(first) THEN        ! initializing
        coef = rpar(10) ! transformation 1/GeV**2 to mb 
        coef = coef / (2.d0*2.d0 * 3.d0*3.d0) 
        mt = mq(6)
        mt2 = mt**2
        mt4 = mt**4
        mt6 = mt**6
       print*,'  Contributed code:   '
       print*,'  Rui Santos and Pedro Ferreira --> '
       print*,'  FCNC top-gluon-quark interaction '
       print*,'                     '
       first=.FALSE.
      ENDIF
*
           if(abs(iq3).eq.2) iqf = 11
           if(abs(iq3).eq.4) iqf = 12
*
       s = (p1(4) + p2(4))**2 - (p1(1) + p2(1))**2
     &   - (p1(2) + p2(2))**2 - (p1(3) + p2(3))**2
       s2 = s * s
  
       t = (p1(4) - p4(4))**2 - (p1(1) - p4(1))**2
     &   - (p1(2) - p4(2))**2 - (p1(3) - p4(3))**2
       t2 = t * t
       sat = s + t
       mt2sm = mt2 - S
*
*      print*,'iqf ',iqf
*      print*,'HR HL ',HR(iqf),HL(iqf)
*      print*,'XR XL ',XR(iqf),XL(iqf)
*      print*,'YR YL ',YR(iqf),YL(iqf)



       alctCR = XR(iqf) + YR(iqf) ! C_TR(iqf)
       alctR  = conjg(alctCR)

       altcR  = - YR(iqf)         ! C_XR(iqf) - C_TR(iqf)
       altcCR = conjg(altcR)

       alctCL =  XL(iqf) + YL(iqf) ! C_TL(iqf)
       alctL  = conjg(alctCL)

       altcL  = - YL(iqf)          ! C_XL(iqf) - C_TL(iqf)
       altcCL = conjg(altcL)

       betc   = -ei*HR(iqf)        ! C_HR(iqf)
       betcC  = conjg(betc)
       bectC  = -ei*HL(iqf)        ! C_HL(iqf)
       bect   = conjg(bectC)

********************

      U1 =  mt4 - 2.d0*sat*mt2 + s2 + 2.d0*t2 + 2*s*t
      A1 = -2.d0*alctCR*altcCR * (mt2+s)* U1 

      A2 = -2.d0*alctCR*alctR *
     &mt2sm*((mt2 + s)**2 + 2.d0*t2 - 2.d0*(mt2 - s)*t)

      A3 = -8.d0*ei*alctCR*betcC * mt*(mt4-2.d0*t*mt2-s2+2.d0*t*sat) 
      A4 = -2.d0*altcCR*altcR*mt2sm* U1

      A5 =  8.d0*ei*altcCR*betc * mt      * U1
      A6 = -2.d0*alctR*altcR    * (mt2+s) * U1
      A7 = -8.d0*ei*altcR*betcC * mt      * U1
      A8 =  8.d0*ei*alctR *betc * mt*(mt4-2.d0*t*mt2-s2+2.d0*t*sat)
      A9 = -2.d0*alctCL*altcCL   * (mt2+s) * U1 

      A10 = -2.d0*alctCL*alctL*mt2sm*((mt2+s)**2+2.d0*t2
     & -2.d0*mt2sm*t)

      A11 = -8.d0*ei*alctCL*bect*mt*(mt4-2.d0*t*mt2-s2+2.d0*t*(s + t))
      A12 = (-2.d0*altcCL*altcL*(mt2 - s) 
     &    +   8.d0*ei*altcCL*bectC* mt 
     &    -   2.d0*alctL*altcL*(mt2+s)
     &    -   8.d0*ei*altcL*bect* mt    ) * U1

      A13 =  8.d0*ei*alctL*bectC*mt*(mt4-2.d0*t*mt2-s2 + 2.d0*t*sat)
      A14 = -32.d0*(bect*bectC + betc*betcC) *
     & (mt4-(s+2.d0*t)*mt2 + 2.d0*t*sat)

      U0 = a1+a2+a3+a4+a5+a6+a7+a8+a9+a10+a11+a12+a13+a14 

*** polarization
      
      call epsil3(p4, p1, p2, EPSL)

      do J = 1,4
      EGR =  -2.d0*ei*(mt2 - s - 2.d0*t)*EPSL(j)
      B1 = 4.d0 * alctCR * altcCR * mt *
     & ((mt2-s)*(P1(J)*mt2-P1(J)*t + P2(J)*(s+t)) + EGR)

      B2 = 4.d0 * alctCR * alctR * mt *
     & (4.d0*P2(J)*t*mt2 - 2.d0*(P1(J)+P2(J))*t2 
     &  + (mt4-s2)*(P1(J)-P2(J)) - 4.d0*s*P1(J)*t)

      B3 = 8.d0 * ei * alctCR * betcC * 
     &( (2.d0*P1(J)-P2(J))*mt4 
     & + (-s*P1(J) - t*P1(J) + s*P2(J) + 5.d0*P2(J)*t)*mt2
     & -  (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t) + EGR )

      B4 = 4.d0 * altcCR * altcR * mt *
     & (P1(J) + P2(J))*(mt4 - 2.d0*(s+t)*mt2 + s2 + 2.d0*t2 + 2.d0*s*t)

      B5 = - 8.d0 * ei * altcCR * betc * 
     & ((2.d0*P1(J) + P2(J))*mt4 - (3.d0*P1(J) + P2(J))*(s+t)*mt2 
     & + (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t) + EGR)

      B6 = 4.d0 * alctR * altcR * mt *
     & ((mt2 - s)*(P1(J)*mt2 - P1(J)*t + P2(J)*(s + t)) - EGR)

      B7 = 8.d0*ei * altcR * betcC * 
     & ((2.d0*P1(J) + P2(J))*mt4 - (3.d0*P1(J) + P2(J))*(s+t)*mt2 
     & + (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t) - EGR)

      B8 = 8.d0*ei* alctR * betc * 
     & (EGR - ((2.d0*P1(J) - P2(J))*mt4 
     &  + (-s*P1(J) - t*P1(J) + s*P2(J) + 5.d0*P2(J)*t)*mt2
     &  - (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t)))

      B9 = 4.d0 * alctCL * altcCL * mt *
     & ( EGR - (mt2 - s)*(P1(J)*mt2 - P1(J)*t + P2(J)*(s+t)))

      B10 = - 4.d0 * alctCL * alctL * mt *
     & (4.d0*P2(J)*t*mt2 - 2.d0*(P1(J) + P2(J))*t2 
     & + (mt4 - s2)*(P1(J) - P2(J)) - 4.d0*s*P1(J)*t)

      B11 = 8.d0 * ei * alctCL * bect * 
     & ( EGR - ((2.d0*P1(J) - P2(J))*mt4 
     & + (-s*P1(J) - t*P1(J) + s*P2(J) + 5.d0*P2(J)*t)*mt2 
     & - (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t)))

      B12 = -4.d0 * altcCL * altcL * mt *
     & (P1(J) + P2(J))*(mt4 - 2.d0*(s+t)*mt2 + s2 + 2.d0*t2 + 2.d0*s*t)

      B13 = 8.d0*ei* altcCL * bectC *
     & ((2.d0*P1(J) + P2(J))*mt4 - (3.d0*P1(J) + P2(J))*(s+t)*mt2 
     & + (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t) - EGR )

      B14 = - 4.d0 * alctL * altcL * mt *
     & ((mt2 - s)*(P1(J)*mt2 - P1(J)*t + P2(J)*(s+t)) + EGR )

      B15 = - 8.d0 * ei * altcL * bect * 
     & ((2.d0*P1(J) + P2(J))*mt4 - (3.d0*P1(J) + P2(J))*(s+t)*mt2
     & + (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t) + EGR )

      B16 = 8.d0*ei * alctL * bectC * 
     & ((2.d0*P1(J) - P2(J))*mt4 
     & + (-s*P1(J) - t*P1(J) + s*P2(J) + 5.d0*P2(J)*t)*mt2 
     & - (s + 2.d0*t)*(s*P1(J) + (P1(J) + P2(J))*t) + EGR )

      B17 = 64.d0 * (-bect * bectC + betc * betcC) * mt *
     & (P1(J)*mt2 - s*P1(J) + (P2(J) - P1(J))*t)


      b0 =  b1 +  b2 +  b3 +  b4 +  b5 +  b6 +  b7 + b8 + b9 + b10 
     &   + b11 + b12 + b13 + b14 + b15 + b16 + b17
      sp(j) = dble(b0 / u0)
      enddo

      call vortas(p4, vh)
       do j = 1,3
        hv(j) = -(sp(4)*vh(j,4) - sp(1)*vh(j,1) - sp(2)*vh(j,2) 
     &                          - sp(3)*vh(j,3))
       enddo

      ves = (u0 / S) * coef * rpar(16)**2
      return
      end
