c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  24/06/2000                                  *
      double precision Function TopWid(IQ, mt) 
*     ---------------                                                        *
*   Width of the top decay t -> W q evaluated in LO                          *
*   return the SM total top decay (in GeV)                                   *
*   IQ = 1(d), 3(s), 5(b)  light quark flavor                                *
*............................................................................*

      implicit none
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision mq,       mq2
      common /massql/  mq(0:20), mq2(0:20)
      double precision mt,p(5),q(5),pw(5),l(5),n(5),ps1(5),ves
      include "txpar.inc" 
      integer IQ, I
      double precision CKM2
      common /CKMD/    CKM2(-6:6,-6:6)
      integer Ntot
      data ntot/10000/
*
      TopWid = 0.d0 
      if(iq.eq.1.OR.iq.eq.3.OR.iq.eq.5) then 
       TopWid = 0.d0
       call zer5mom(p) 
       p(5) = mt
       p(4) = mt
       q(5) = mq(iq)
      do I = 1, Ntot
        call top_dec_wff(iq,  p, q, pw, l, n, ps1, ves)
        TopWid = TopWid + VES
      enddo
      TopWid = TopWid * CKM2(6, iq) / Ntot  ! times to Vtq**2
      endif
      return
      end
