c----------------------------------------------------------------------------*
*... author  :  Serge Slabospitsky                                           *
*... 02.07.2006                                                              *
*... search sing Top in FCNC 2 -> 1 and 2 -> 2 processes in PYJETS list      *
*... should be applied for TopReX process with txsel = 2                     *
*... search Bbar (B) additional to TOP(TOPbar) in PYJETS list                *
*... should be applied for TopReX process with ipar(1) = 1 and 2             *
*............................................................................*
*
	Subroutine tx_mtch0(kmc, pmc) 
*	-------------------
*
      Implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      INTEGER         NN, NPAD, KK
      DOUBLE PRECISION                      PP,         VV
      COMMON /PYJETS/ NN, NPAD, KK(4000,5), PP(4000,5), VV(4000,5)
      integer I
      integer        kmc, ks, kb 
      double precision  pmc(5) 
*
       kmc = 0
        do i = 1,5
         pmc(i) = 0.d0
        enddo 
       if(txsel.le.0) return 
      IF(txsel.eq.1) then
       kb = 0
       kmc = 0
        do i = 5, NN
         if(abs(kk(i,2)).eq.6) goto 21
        enddo
       return      ! no top-quark 
 21   ks = I ! top
       do i = ks, NN
        if((kk(i,2)*kk(ks,2)).eq.-30) goto 22 
       enddo
      return      ! no requested b-quark
 22   kmc = I 
        do I = 1,5
         Pmc(I)   = PP(kmc, I)
        enddo
       kmc = kk(kmc,2)
       return
      ENDIF
*
      IF(txsel.eq.2) then
        kb = 0
        ks = 0
       If(Ipar(1).eq.30) then
         do i = 7, NN 
          if(kb.ge.1.and.ks.ge.1) goto 23
          if(abs(kk(i,2)).eq.5)  kb = I
          if(abs(kk(i,2)).eq.24) ks = I
         enddo
 23      continue
       if(kb.eq.0.or.ks.eq.0) then
         print*,'TopReX matching for FCNC single top'
         print*,'process 30: 2 -> 1  - no B or W',kb,ks
         print*,'stop run'
          STOP   ! no t-quark is found
        endif                 
        do I = 1,5
         Pmc(I)   = PP(kb, I) + PP(ks, I)
        enddo
       kmc = +1 
      ElseIf(Ipar(1).eq.31.OR.Ipar(1).eq.32.
     &    OR.Ipar(1).eq.33) then
        kmc = 0
       do i = 7, NN
        if(kmc.ge.1) goto 24
        if(abs(kk(i,2)).eq.6)  kmc = I
       enddo
 24    continue
       if(kmc.eq.0) then
        print*,'TopReX matching for FCNC single top'
        print*,'process 31 or 32 or 33: 2 -> 2  - no TOP'
        print*,'stop run'
         STOP    ! no t-quark is found
       endif                 
        do I = 1,5
         Pmc(I)   = PP(kmc, I) 
        enddo
       EndIf
       return
      ENDIF
      return
      end
