c----------------------------------------------------------------------------c
* for multiple processes

      subroutine TX_MULT
      implicit none
      Integer           Ipar     ! global TopRex integer parameters  
      double precision  Rpar     ! global TopRex real    parameters
      common /TXPAR/Ipar(200), Rpar(200)
      save   /TXPAR/
      integer I 
      integer  maxpro 
      parameter (maxpro=500)
      integer         txmup, txsel, txpro,      txext
      common /trxpro/ txmup, txsel, txpro(maxpro), txext(maxpro)
      save   /trxpro/
C...User process event common block 
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      double precision EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
      integer         MSTP,               MSTI 
      double precision          PARP,               PARI      
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)
*
      If(txsel.eq.-1) return ! PYTHIA process 
      If(txsel.ge.1) then 
         do i = 1,maxpro
          txpro(i) = 0
         enddo 
       if(txsel.eq.1) then
        txpro(1) = 1
        txpro(2) = 1
       elseif(txsel.eq.2) then
        txpro(30) = 1
        txpro(31) = 1
        txpro(32) = 1
        txpro(33) = 1
       else
        print*,' TXSEL value ',txsel,' is not implemented. Stop'
        stop 
       endif
      Else ! txsel <= 0
       txmup = 0
       do I = 1, maxpro
        if(txpro(I).eq.1) txmup = txmup + 1
       enddo
        if(txmup.eq.0) then
        print*,' no TopReX process is switched-ON. Stop'
        stop 
        endif
       if(txpro(1).eq.1.and.txpro(2).eq.1) then
         if(txmup.ge.3) then
          print*,' No other process can be generated with '
         print*,' Single top (2->2) and (2->3) production. Stop'
         stop 
        endif
        txsel = 1
        TXpro(1) = 1
        TXpro(2) = 1
       endif  
      if( txpro(30).eq.1.and.txpro(31).eq.1.
     &and.txpro(32).eq.1.and.txpro(33).eq.1) then
         if(txmup.ge.5) then
          print*,' No other process can be generated with '
         print*,' FCNC (t-gluon-q) single top production. Stop'
         stop 
        endif
        txsel = 2
      endif 
      EndIf

****
       txmup = 0
       do I = 1, maxpro
        if(txpro(I).eq.1) then
         txmup = txmup + 1
         ipar(1) = I
         call TX_NAM(0) 
         nprup = txmup
         lprup(txmup) = ipar(1)
         txext(I) = txmup
        endif
       enddo
****
       if(txmup.eq.0) then
        print*,' no TopReX process is switched-ON. Stop'
        stop 
       endif
        if(txsel.ge.1) mstp(143) = 1
*
      return
      end
