c----------------------------------------------------------------------------c
C..TXGIVE V:1.02,   17/08/2006
C rewritten from PYGIVE routine from PYTHIA
C...Sets values of commonblock variables.
 
      SUBROUTINE TXGIVE(CHIN)
      implicit none 
      Integer           Ipar     ! global TopRex integer parameters  
      double precision  Rpar     ! global TopRex real    parameters
      common /TXPAR/Ipar(200), Rpar(200)
      save   /TXPAR/
**********
      integer ndch   ! maximum number of decay channels
      parameter (ndch=50)
      integer dectop(ndch), dechpm(ndch) 
      common /TXdecRE/dectop, dechpm 
      save /TXdecRE/
*...........
      integer  maxpro 
      parameter (maxpro=500)
      integer         txmup, txsel, txpro,         txext
      common /trxpro/ txmup, txsel, txpro(maxpro), txext(maxpro)
      save   /trxpro/
*............
      integer Irtyp 
      double precision an_FL,an_FR,an_HL,an_HR,an_XL,an_XR,an_YL,an_YR
      common /CTOPINI/Irtyp(20), an_FL(2,20), an_FR(2,20),
     &   an_HL(2,20), an_HR(2,20), an_XL(2,20), an_XR(2,20), 
     &   an_YL(2,20), an_YR(2,20) 
      save /CTOPINI/
***
      integer IER, I, J, IL, k1, k2 , Iread
      integer lenk
      parameter (lenk=132)
      character *(*) chin
      character *60 inam, rnam
      character *20 cvi  ! , cvj
      character *132 STRIN 
      character *132 strin2
      data strin2/'PROCESS : not given'/
      save strin2

*   for TAUOLA package
      integer            PJAK1, PJAK2, MDTAU
      common /ki_taumod/ PJAK1, PJAK2, MDTAU
      data pjak1/-1/, pjak2/ -1/, mdtau/-1/
      save /ki_taumod/ 
*
      character*132                            CXpar
      integer         Ixpar 
      double precision            RXpar
      common /EXGPAR/ IXpar(100), RXpar(100), CXpar(100)
      data IXpar/1, 99*0/
      save /EXGPAR/ 
      logical first
      data first /.TRUE./
      save first
****
*
* read name of the process
*
      IF(first) then
        first=.FALSE.
         do j = 1,ndch
          dectop(j)  = -1
          dechpm(j)  = -1
         enddo
           do j = 1,100
             do i = 1,lenk
              cxpar(j)(i:i) = ' '
             enddo
            enddo
      ENDIF
***
      Iread = 1
      ier = 1
      Inam = 'unwfile = ' ! for alpgen
        call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) then
           Iread = 0
           call strnum(chin, k1, k2)
            if(k1.ge.1.and.k2.ge.k1) then
                do i = 1,lenk
                 cxpar(1)(i:i) = ' '
                enddo
             ixpar(99) = k2 - k1 + 1
             ixpar(100) = ixpar(99) + 1
             cxpar(1)(1:ixpar(99)) = chin(k1:k2)
            endif
*        print*,'UNFILE k1 k2 cxpar ',k1,k2,cxpar(1)
         endif
***
      Inam = 'evfile = '        ! for Madgraph and CompHEP
        call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) then
            Iread = 0
          call strnum(chin, k1, k2)
            if(k1.ge.1.and.k2.ge.k1) then
                do i = 1,lenk
                 cxpar(1)(i:i) = ' '
                enddo
             ixpar(99) = k2 - k1 + 1
              cxpar(1)(1:ixpar(99)) = chin(k1:k2)
*            cxpar(1) = chin(k1:k2)
             ixpar(100) = k2 - k1 + 2
            endif
*        print*,'EVFILE k1 k2 cxpar ',k1,k2,cxpar(1)
         endif
*
      Inam = 'PROCESS = '
        call TXRSTR2(inam, chin, strin, ier) 
*        print*,'** IER ' ,ier,' process ',chin 
         if(ier.eq.0) then
            Iread = 0
           do i = 1,lenk
             cxpar(2)(i:i) = ' '
             strin2(i:i) = ' '
            enddo
           strin2 = chin
*           cxpar(2) = chin
*           print*,cxpar(2) 
          endif
           cxpar(2) = strin2
*
      do I = 1,100
       call intochar(I, il, cvi)
        Rnam = 'rxpar('//cvi(1:il)//')'//' = '
        call TXRSTR2(rnam, chin, strin, ier) 
         if(ier.eq.0) Iread = 0
         if(ier.eq.0) read(strin(1:lenk),*) RXpar(i) 
        Inam = 'ixpar('//cvi(1:il)//')'//' = '
        call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) read(strin(1:lenk),*) IXpar(i) 
         if(ier.eq.0) Iread = 0
      enddo
*
      do I = 1,200
        call intochar(I, il, cvi)
         Inam = 'ipar('//cvi(1:il)//')'//' = '
         Rnam = 'rpar('//cvi(1:il)//')'//' = '
        call TXRSTR2(rnam, chin, strin, ier) 
         if(ier.eq.0) read(strin(1:lenk),*) Rpar(i) 
        if(ier.eq.0) Iread = 0
        call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) read(strin(1:lenk),*) Ipar(i) 
        if(ier.eq.0) Iread = 0
      enddo
*
         Inam = 'txsel '//' = '
        call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) txsel 
        if(ier.eq.0) Iread = 0
      do I = 1, maxpro
        call intochar(I, il, cvi)
        Inam = 'txpro('//cvi(1:il)//')'//' = '
        call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) txpro(i) 
        if(ier.eq.0) Iread = 0
      enddo
* read decay channels
*     IT = 1 : top quark,  IT = 2 : W-boson, 
*     IT = 3 : H+- boson,  IT = 4 : Z-boson 
      do I = 1, ndch 
        call intochar(I, il, cvi)
*  top quark
         inam = 'dectop('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) read(strin(1:lenk),*) dectop(i) 
        if(ier.eq.0) Iread = 0
*  H+- boson 
         inam = 'dechpm('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) read(strin(1:lenk),*) dechpm(i) 
         if(ier.eq.0) Iread = 0
**  W-boson 
*         inam = 'decwpm('//cvi(1:il)//') ='
*         call TXRSTR2(inam, chin, strin, ier) 
*         if(ier.eq.0) read(strin(1:lenk),*) decwpm(i) 
*         if(ier.eq.0) Iread = 0
*  Z-boson
*         inam = 'decZ0('//cvi(1:il)//') ='
*         call TXRSTR2(inam, chin, strin, ier) 
*         if(ier.eq.0) read(strin(1:lenk),*) decz0(i) 
*         if(ier.eq.0) Iread = 0
      enddo 

      do I = 1,20 
        call intochar(I, il, cvi)
        inam = 'Irtyp('//cvi(1:il)//') ='
        call TXRSTR2(inam, chin, strin, ier) 
         if(ier.eq.0) read(strin(1:lenk),*) irtyp(i)
         if(ier.eq.0) Iread = 0
      enddo 
****
      do I = 1,20 
        call intochar(I, il, cvi)
*
* FL
        ier = 1
         inam = 'an_fl('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_fl(1,i), an_fl(2,i)
        if(ier.eq.0) Iread = 0
* FR
        ier = 1
         inam = 'an_fr('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_fr(1,i), an_fr(2,i)
        if(ier.eq.0) Iread = 0
*** HL
        ier = 1
         inam = 'an_hl('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_hl(1,i), an_hl(2,i)
        if(ier.eq.0) Iread = 0
* HR
        ier = 1
          inam = 'an_hr('//cvi(1:il)//') ='
          call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_hr(1,i), an_hr(2,i)
        if(ier.eq.0) Iread = 0
*** XL
        ier = 1
         inam = 'an_xl('//cvi(1:il)//') ='
          call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_xl(1,i), an_xl(2,i)
        if(ier.eq.0) Iread = 0
* XR
        ier = 1
          inam = 'an_xr('//cvi(1:il)//') ='
          call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_xr(1,i), an_xr(2,i)
        if(ier.eq.0) Iread = 0
*** YL
        ier = 1
         inam = 'an_yl('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_yl(1,i), an_yl(2,i)
        if(ier.eq.0) Iread = 0
* YR
        ier = 1
         inam = 'an_yr('//cvi(1:il)//') ='
         call TXRSTR2(inam, chin, strin, ier) 
        if(ier.eq.0) read(strin(1:lenk),*) an_yr(1,i), an_yr(2,i)
        if(ier.eq.0) Iread = 0
      enddo 
* read TAUOLA parameters
       ier = 1
       inam = 'tauola ='
       call TXRSTR2(inam, chin, strin, ier) 
       if(ier.eq.0) read(strin(1:lenk),*) pjak1, pjak2, mdtau
       if(ier.eq.0) Iread = 0
****
      IF(IXpar(1).eq.1.OR.IXpar(1).eq.2) then
        if(Iread.eq.0) return 
        k1 = 0
        k2 = 0
      do i = 1,lenk
       If(k1.eq.0.AND.
     &  (ichar(chin(i:i)).ge.33.and.
     &   ichar(chin(i:i)).le.126)) then
          k1 = i
        EndIf
         if(chin(i:i).eq.'=') then
           k2 = i 
           goto 152
         endif
      enddo
 152  continue
       if(k1.eq.0.or.k2.eq.0) then 
         print*,'TXGIVE: do not recognize input : ',chin
       else
        if(k2.eq.0) k2 = lenk
         k2 = k2 - 1
         print*,'TXGIVE: do not recognize input parameter : ',
     &    chin(k1:k2)
       endif
       if(IXpar(1).eq.2) then
         print*,'STOP '
         stop
       endif
      ENDIF
      return
      end
