*----------------------------------------------------------------------------*
* V^mu = SpinorString * GAMMA^mu * SpinonColumn 
* GV = gamma^nu * V^nu gluon
      subroutine Us_gluon_Uc(P, N, gs, X, Y, GV) 
*     ------------------------------------------
      implicit none
      double complex gs, X(2,4), Y(2,4)
      double complex G(4), GV(2,2,4,4)
      double complex A, B, PP, PM, P1, P2, PG, NG 
      double complex kp, km, k1, k2, np, nm, n1, n2
      double complex kkp, kkm, kk1, kk2
      double precision P(5), N(6) 
      double complex ei 
      data ei/(0.d0, 1.d0)/
      integer I, J, j1,j2
*
       do 11 i = 1,2
       do 11 j = 1,2
       do 11 j1 = 1,4
       do 11 j2 = 1,4
 11      GV(i,j,j1,j2) = (0.d0, 0.d0)

      kp = (p(4) + p(3))     / n(6)
      km = (p(4) - p(3))     / n(6)
      k1 = (p(1) + ei * p(2))/ n(6)
      k2 = (p(1) - ei * p(2))/ n(6)
*
      kkp = n(5)*(p(4) + p(3))     / n(6) / n(6)
      kkm = n(5)*(p(4) - p(3))     / n(6) / n(6)
      kk1 = n(5)*(p(1) + ei * p(2))/ n(6) / n(6)
      kk2 = n(5)*(p(1) - ei * p(2))/ n(6) / n(6)
      np = (n(4) + n(3))     / n(6)
      nm = (n(4) - n(3))     / n(6)
      n1 = (n(1) + ei*n(2))  / n(6)
      n2 = (n(1) - ei*n(2))  / n(6)
*
      do I = 1,2
      do j = 1,2    
       A  = X(i,3)*Y(j,1) + X(i,4)*Y(j,2)
       B  = X(i,1)*Y(j,3) + X(i,2)*Y(j,4) 
        G(4)  = A + B 
       A =  X(i,3)*Y(j,1) - X(i,4)*Y(j,2)
       B = -X(i,1)*Y(j,3) + X(i,2)*Y(j,4) 
        G(3)  = A + B
       A = ei * ( X(i,4)*Y(j,1) - X(i,3)*Y(j,2))
       B = ei * (-X(i,2)*Y(j,3) + X(i,1)*Y(j,4))
        G(2)  = A + B
       A =        X(i,4)*Y(j,1) + X(i,3)*Y(j,2)
       B =       -X(i,2)*Y(j,3) - X(i,1)*Y(j,4) 
        G(1)  = A + B
*
      PG = P(4)*G(4) - P(1)*G(1) - P(2)*G(2) - P(3)*G(3)
      NG = N(4)*G(4) - N(1)*G(1) - N(2)*G(2) - N(3)*G(3)

       PP = G(4) + G(3) 
       PM = G(4) - G(3) 
       P1 = G(1) + ei*G(2) 
       P2 = G(1) - ei*G(2) 
       PP = PP  - kp * ng - np * pg + kkp * pg
       PM = PM  - km * ng - nm * pg + kkm * pg
       P1 = P1  - k1 * ng - n1 * pg + kk1 * pg
       P2 = P2  - k2 * ng - n2 * pg + kk2 * pg
        GV(I,J,1,3) =  gs * PP 
        GV(I,J,1,4) =  gs * P2 
        GV(I,J,2,3) =  gs * P1 
        GV(I,J,2,4) =  gs * PM 

        GV(I,J,3,1) =  gs * PM 
        GV(I,J,3,2) = -gs * P2 
        GV(I,J,4,1) = -gs * P1 
        GV(I,J,4,2) =  gs * PP 
      enddo
      enddo
      RETURN
      END
