*----------------------------------------------------------------------------*
      FUNCTION APMPM(S,T,U,EMZ2,EQ2,B,A2PB2,A2MB2)
      IMPLICIT REAL*8(A-H,O-Z)
      double complex APMPM
      COMPLEX*16 BI(4),CI(4),DI(3)
      COMMON/CINTS/BI,CI,DI
      Y=U*T-EMZ2**2
      S4=S-4.D0*EMZ2
      S2=S-2.D0*EMZ2
      T1=T-EMZ2
      U1=U-EMZ2
      APMPM=A2PB2*
     1 (4.D0*S/Y*((S/Y*(1+B*(T-U)/S4)-2.D0/S4)*
     2  (S2*(S*S4+EMZ2**2)*CI(1)+S4*(S*S4+3.D0*EMZ2**2)*CI(4)
     3   +T**4*(2.D0*CI(2)/T1+DI(1))+U**4*(2.D0*CI(3)/U1+DI(2)))
     4  +2.D0*EMZ2**2/S4*(T1*(T+EMZ2)*(2.D0*CI(2)/T1+DI(1))
     5                       +U1*(U+EMZ2)*(2.D0*CI(3)/U1+DI(2)))
     6  *(1.D0+B*(T-U)/S4)
     7  +(2.D0*S2*BI(1)+2.D0*T**3/T1**2*BI(2)
     8   +2.D0*U**3/U1**2*BI(3)-S*S2*CI(1)-(S*S4+2.D0*EMZ2**2)*CI(4)
     9   +2.D0*U**2*(2.D0*S+U)/U1*CI(3)+2.D0*T**2*(2.D0*S+T)/T1*CI(2)
     1   +2.D0*T**2*S*DI(1)+2.D0*U**2*S*DI(2))*(1.D0+B*(T-U)/S4)
     2  +2.D0*EQ2*(1.D0+B*(T-U)/S4)*(S2*CI(1)+S4*CI(4)
     3      +2.D0*U**2*(CI(3)/U1+DI(2))+2.D0*T**2*(CI(2)/T1+DI(1))))
     4  +16.D0*EQ2**2*(DI(1)+DI(3)+DI(2))
     5  +4.D0*EQ2/S4*
     6     ((8.D0*EMZ2/S*(S*S4-Y)+4.D0*U1*S4*(1.D0-B*S/S4))*CI(3)/U1
     7     +(8.D0*EMZ2/S*(S*S4-Y)+4.D0*T1*S4*(1.D0+B*S/S4))*CI(2)/T1
     8     +2.D0*S2*Y/S*DI(3)
     9     +(S*S2*(1.D0-4.D0*B)-2.D0*EMZ2*(S+2.D0*EMZ2)
     1                                  +3.D0*S*(T-U)*B)*DI(1)
     2     +(S*S2*(1.D0+4.D0*B)-2.D0*EMZ2*(S+2.D0*EMZ2)
     3                                  +3.D0*S*(T-U)*B)*DI(2))
     4  +8.D0/S4/U1/T1*(S2*Y+EMZ2*S*B*(T-U))
     5  -8.D0*S2/S4*BI(1)
     6  +4.D0*S/S4*(S2*CI(1)+S4*CI(4))
     7  +4.D0/S4*
     8  (((T*(T*S2+2.D0*EMZ2*S4)+EMZ2**2*S2)
     9    +B*(T*(3.D0*T*S-2.D0*S*EMZ2)-S*EMZ2**2))*BI(2)/T1**2
     1  +((U*(U*S2+2.D0*EMZ2*S4)+EMZ2**2*S2)
     2    -B*(U*(3.D0*U*S-2.D0*S*EMZ2)-S*EMZ2**2))*BI(3)/U1**2)
     3  +64.D0*B*EMZ2**3/S4**2*(T1*(2.D0*CI(2)/T1+DI(1))
     4                         -U1*(2.D0*CI(3)/U1+DI(2)))
     5  +4.D0/S4*
     6  ((-(T**2*(3.D0*S+2.D0*EMZ2)-T*S*(4.D0*S-10.D0*EMZ2)
     7   +EMZ2**2*(3.D0*S+2.D0*EMZ2))
     8  +B*(3.D0*T**2*S+T*(4.D0*S*S+2.D0*EMZ2*S+8.D0*EMZ2**2)
     9   -EMZ2**2*(5.D0*S+8.D0*EMZ2)))*CI(2)/T1
     1  +(-(U**2*(3.D0*S+2.D0*EMZ2)-U*S*(4.D0*S-10.D0*EMZ2)
     2   +EMZ2**2*(3.D0*S+2.D0*EMZ2))
     3  -B*(3.D0*U**2*S+U*(4.D0*S*S+2.D0*EMZ2*S+8.D0*EMZ2**2)
     4   -EMZ2**2*(5.D0*S+8.D0*EMZ2)))*CI(3)/U1)
     5  +1.D0/S4*
     6  (((-8.D0*T**2*S+6.D0*T*S*S2-8.D0*S*EMZ2**2)
     7   +B*(16.D0*T1*EMZ2**2+10.D0*T*S*S-8.D0*EMZ2**2*S))*DI(1)
     8  +((-8.D0*U**2*S+6.D0*U*S*S2-8.D0*S*EMZ2**2)
     9   -B*(16.D0*U1*EMZ2**2+10.D0*U*S*S-8.D0*EMZ2**2*S))*DI(2)))
     1   +A2MB2*
     2  (4.D0*EQ2/S4*DI(3)*(S*S4*(1.D0-B*(T-U)/S4)-2.D0*Y))
      RETURN
      END
