*----------------------------------------------------------------------------*
      FUNCTION BOX(S,T,U,EH2,EQ2)
      IMPLICIT REAL*8(A-H,O-Z)
      double complex BOX
      COMPLEX*16 CI1,CI2,RM1,R1,SP
      COMMON/EMCUT/EMCUT2,PIE,RM1
      IF(EQ2.GT.EMCUT2)THEN
      BE1=-U/(EH2-U)
      V=-DSQRT(1.D0-4.D0*EH2/S)
      BE2=0.5D0*(1.D0+V)
      ROOT=DSQRT(S*S*U*U+4.D0*EQ2*S*(U*T-EH2*EH2))
      Y1P=(-U+ROOT/S)/2.D0/(U-EH2)
      Y1M=(-U-ROOT/S)/2.D0/(U-EH2)
      Y2P=(-EH2+EH2*V-V*U+ROOT/S)/2.D0/(U-EH2+(S-S*V)/2.D0)
      Y2M=(-EH2+EH2*V-V*U-ROOT/S)/2.D0/(U-EH2+(S-S*V)/2.D0)
      BOX=1.D0/ROOT*(
     1 -CI1(S,0.D0,BE1+Y1P)+CI1(S,0.D0,BE1+Y1M)
     2 +CI1(EH2-T,EH2-U,Y1P/(1.D0-BE1))-CI1(EH2-T,EH2-U,Y1M/(1.D0-BE1))
     3 -CI1(U-EH2,EH2-U,-Y1P/BE1)+CI1(U-EH2,EH2-U,-Y1M/BE1)
     4 +CI1(S,0.D0,BE2+Y2P)-CI1(S,0.D0,BE2+Y2M)
     5 -CI1(EH2-T,EH2-U,Y2P/(1.D0-BE2))+CI1(EH2-T,EH2-U,Y2M/(1.D0-BE2))
     6 +CI1(U-EH2,EH2-U,-Y2P/BE2)-CI1(U-EH2,EH2-U,-Y2M/BE2)
     7 -CI2(EQ2,EH2,Y1P/(1.D0-BE1))+CI2(EQ2,EH2,Y1M/(1.D0-BE1))
     8 +CI2(EQ2,U,-Y1P/BE1)-CI2(EQ2,U,-Y1M/BE1)
     9 -CI2(EQ2,S,Y2P+BE2)+CI2(EQ2,S,Y2M+BE2)
     1 +CI2(EQ2,EH2,Y2P/(1.D0-BE2))-CI2(EQ2,EH2,Y2M/(1.D0-BE2))
     2 -CI2(EQ2,EH2,-Y2P/BE2)+CI2(EQ2,EH2,-Y2M/BE2))
      ELSEIF(EQ2.LE.EMCUT2)THEN
      X=U/(U-EH2)
      EM2=EQ2/X**2
      R1=X
      BOX=1.D0/S/U*(
     1 4.D0*SP(R1)+0.5D0*(DLOG(EQ2/S))**2
     2 +2.D0*DLOG(EQ2/S)*DLOG((1.D0-X)/X)+2.D0*(DLOG(X))**2+PIE**2/6.D0
     2 +RM1*PIE*(2.D0*DLOG(X*(1.D0-X))-DLOG(EQ2/S)) )
      ENDIF
      RETURN
      END
