c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  03.07.2006                                  *
*   FCNC top production : 2 -> 1  including SM contribution  gu(c)->bW       *
*   TopReX code = 30                                                         *
*   color flow and showering description for PYTHIA                          *
      subroutine COLORF_30(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer ip1, ip2, j, ntop, kpp(2), kftop(2) 
      double precision hrgu   ,hrug   , hrgc   , hrcg   
      common /fcncpol/ hrgu(4),hrug(4), hrgc(4), hrcg(4)
      double precision hv
      common /topol1/  hV(4)    ! TOP polarisation vector
*.................  FCNC :            .......................................*
*     g(U)[1] \                                                              *
*              \                                                             *
*               == T[3]                                                      *
*              /                                                             * 
*     U(g)[2] /                                                              *
*.........................                            .......................*

* HEPEUP :        1     2       3     4 
*       nup = 6 ! 
* how PYTHIA will be treated
        if(idup(1).eq.0) idup(1) = 21
        if(idup(2).eq.0) idup(2) = 21
        istup(3) =  2 ! final top
* parent's lines
        mothup(1,3)=1 
        mothup(2,3)=2  
* KF code
         idup(3) = 6 
         if(ip1.lt.0.OR.ip2.lt.0) idup(3) = -6 !  antitop
* colors flow
        ipar(50) = 300
      if(ip1.eq.0)  then   !  GLUON Q      
       icolup(1,1) = ipar(50)      ! color
       icolup(2,1) = ipar(50) + 1  ! anticolor
         if(idup(3).eq.6) then
          icolup(1,2) = ipar(50) + 1
          icolup(2,2) = 0
          icolup(1,3) = ipar(50)
          icolup(2,3) = 0
         else
          icolup(1,2) = 0
          icolup(2,2) = ipar(50)
          icolup(1,3) = 0
          icolup(2,3) = ipar(50) + 1
         endif
      elseif(ip2.eq.0)  then   !  GLUON Q      
       icolup(1,2) = ipar(50)      ! color
       icolup(2,2) = ipar(50) + 1  ! anticolor
        if(idup(3).eq.6) then
         icolup(1,1) = ipar(50) + 1
         icolup(2,1) = 0
         icolup(1,3) = ipar(50)
         icolup(2,3) = 0
        else
         icolup(1,1) = 0
         icolup(2,1) = ipar(50)
         icolup(1,3) = 0
         icolup(2,3) = ipar(50) + 1
        endif
       endif
*
         do j = 1,4
          hv(j) = 0.d0
         enddo
      If(ip1.eq.0) then
        if(abs(ip2).eq.2) then
         do j = 1,4
          hv(j) = hrgu(j)
         enddo
        elseif(abs(ip2).eq.4) then
         do j = 1,4
          hv(j) = hrgc(j)
         enddo
        endif
      ElseIf(ip2.eq.0) then
        if(abs(ip1).eq.2) then
         do j = 1,4
          hv(j) = hrug(j)
         enddo
        elseif(abs(ip1).eq.4) then
         do j = 1,4
          hv(j) = hrcg(j)
         enddo
        endif
      EndIf

      ntop = 1
         kpp(ntop) = 3
         kftop(ntop) = idup(3)
       if(ntop.ge.1) call top_decay(ntop, kpp, kftop) 
      return
      end
