
*----------------------------------------------------------------------------*
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  17/01/2006                                  *
* the product of two gamma_1(2) x A x gamma_1(2)                             *
*----------------------------------------------------------------------------*
      subroutine gamagam(k1,k2,A,V)
      implicit none
      integer k1,k2, i1, i2
      double complex A(4,4), V(4,4)
      double complex ei
      data ei/(0.d0, 1.d0)/
*******
       do i1 = 1,4
        do i2 = 1,4
         V(i1,i2) = (0.d0, 0.d0)
        enddo
       enddo

      if(k1.eq.1.and.k2.eq.1) then
       V(1, 1) = -A(4,4)
       V(1, 2) = -A(4,3)
       V(1, 3) = +A(4,2)
       V(1, 4) = +A(4,1)
*
       V(2, 1) = -A(3,4)
       V(2, 2) = -A(3,3)
       V(2, 3) = +A(3,2)
       V(2, 4) = +A(3,1)
*
       V(3, 1) = +A(2,4)
       V(3, 2) = +A(2,3)
       V(3, 3) = -A(2,2)
       V(3, 4) = -A(2,1)
*
       V(4, 1) = +A(1,4)
       V(4, 2) = +A(1,3)
       V(4, 3) = -A(1,2)
       V(4, 4) = -A(1,1)
***
      elseif(k1.eq.1.and.k2.eq.2) then
       V(1, 1) = -A(4,4)
       V(1, 2) = +A(4,3)
       V(1, 3) = +A(4,2)
       V(1, 4) = -A(4,1)
*
       V(2, 1) = -A(3,4)
       V(2, 2) = +A(3,3)
       V(2, 3) = +A(3,2)
       V(2, 4) = -A(3,1)
*
       V(3, 1) = +A(2,4)
       V(3, 2) = -A(2,3)
       V(3, 3) = -A(2,2)
       V(3, 4) = +A(2,1)
*
       V(4, 1) = +A(1,4)
       V(4, 2) = -A(1,3)
       V(4, 3) = -A(1,2)
       V(4, 4) = +A(1,1)
***
      elseif(k1.eq.2.and.k2.eq.1) then
       V(1, 1) = +A(4,4)
       V(1, 2) = +A(4,3)
       V(1, 3) = -A(4,2)
       V(1, 4) = -A(4,1)
*
       V(2, 1) = -A(3,4)
       V(2, 2) = -A(3,3)
       V(2, 3) = +A(3,2)
       V(2, 4) = +A(3,1)
*
       V(3, 1) = -A(2,4)
       V(3, 2) = -A(2,3)
       V(3, 3) = +A(2,2)
       V(3, 4) = +A(2,1)
*
       V(4, 1) = +A(1,4)
       V(4, 2) = +A(1,3)
       V(4, 3) = -A(1,2)
       V(4, 4) = -A(1,1)
***
      elseif(k1.eq.2.and.k2.eq.2) then
       V(1, 1) = +A(4,4)
       V(1, 2) = -A(4,3)
       V(1, 3) = -A(4,2)
       V(1, 4) = +A(4,1)
*
       V(2, 1) = -A(3,4)
       V(2, 2) = +A(3,3)
       V(2, 3) = +A(3,2)
       V(2, 4) = -A(3,1)
*
       V(3, 1) = -A(2,4)
       V(3, 2) = +A(2,3)
       V(3, 3) = +A(2,2)
       V(3, 4) = -A(2,1)
*
       V(4, 1) = +A(1,4)
       V(4, 2) = -A(1,3)
       V(4, 3) = -A(1,2)
       V(4, 4) = +A(1,1)
      endif
      if(k1.eq.1.and.k2.eq.2) then
       do i1 = 1,4
        do i2 = 1,4
         V(i1, i2) = ei * V(i1, i2)
        enddo
       enddo
      elseif(k1.eq.2.and.k2.eq.2) then
       do i1 = 1,4
        do i2 = 1,4
         V(i1, i2) = -V(i1, i2)
        enddo
       enddo
      endif
      return
      end
