*----------------------------------------------------------------------------*
*... Authors  : Serge Slabospitsky                                           *
*... 25.01.2001                                                              *
*    q q~' -> W+- ( + H+- )  -> t bbar                                       *
*----------------------------------------------------------------------------*
      subroutine gejzer_04(NFP)
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP         ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision ptop(5),pb(5),q1(5),q2(5),qq(5),ptop1(5),pb1(5) 
      double precision  Ves2, vesm, veslum
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer I, II, J, j1,j2
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision  x1, x2, sgs
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision pdfbt(-5:5, -5:5)
      double precision CKM2
      common /CKMD/ CKM2(-6:6,-6:6)
      double precision PYR, shat, ParL(3), WR(2) 
      integer ncomb 
      parameter (ncomb = 12)
      double precision XEST(0:ncomb), aran
      save  XEST
*
      integer        ju, jd, jt,jb 
      common /isng01/ju, jd, jt,jb 
      integer IB(12), IT(12), IQ 
       data ib/ 2, 2, 2,   4, 4, 4,  -1, -3, -5,  -1, -3, -5/ 
       data it/-1,-3,-5, - 1,-3,-5,   2,  2,  2,   4,  4,  4/ 
      Save IB, IT
*
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*.......
*..ipar(21)      : W-exchange: > 0 tb, <0 tau nu, 1 W, 2 H, 3 (W+H+Int) 
      IF(first) then
       If(    Ipar(1).eq.4.or.txpro(4).eq.1) then
         ipar(21) = -1                        !Ipar(1) = 4 :  W*  -> top bbar
       ElseIf(Ipar(1).eq.8.or.txpro(8).eq.1) then
         ipar(21) = +2                        ! Ipar(1) = 8 : H+- -> top bbar 
       EndIf
      ENDIF

      if(first) goto 103  
       goto 104
 103   continue
      II = 0
 102   II = II + 1
      if(ii.gt.ipar(52)) goto 111
       IQ = 0
 100   IQ = IQ + 1
       if(IQ.GT.ncomb) goto 102
 104  sigrx=0.d0
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
      
* 12 combinations are considered
* 1: u d,  2: u s,  3: u b,  4: c d,  5: c s,  6: c b 
* then two combinations correspond to beam(U) or target(U)

      if(.NOT.first) then  
 106  aran = PYR(0)
       if(aran.ge.xest(ncomb)) goto 106 
       do IQ = 1,ncomb
        if(aran.le.xest(IQ)) goto 105
       enddo 
 105   continue
         if(IQ.LT.0.OR.IQ.GT.ncomb) goto 106
      endif
*...
*  evaluate of the top on-shell mass
*      ptop(5) = TopMV(Rpar(34), mq(6))
      ptop(5) = mq(6)
       Parl(1) = ptop(5) + mq(5) 
       ParL(2) = Rpar(1)
       ParL(3) = Rpar(1)
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
 295  continue 
       q1(5) = mq(abs(IB(iq)))
       q2(5) = mq(abs(IT(iq)))

      if(abs(ipar(21)).eq.1)    then 
       WR(1) = Rpar(41)   ! W-boson mass
       WR(2) = Rpar(44)   ! M(W) * Width(W) 
        if(WR(1).lt.Parl(1).or.WR(1).gt.Parl(2)) then
         call X1X2GEN( ParL, X1, X2, Veslum, q1, q2, QQ)
        else
         call X1X2RES( ParL, WR, X1, X2, Veslum, q1, q2, QQ)
        endif
      elseif(abs(ipar(21)).eq.2) then 
       WR(1) = Rpar(51)   ! H-boson mass
       WR(2) = Rpar(54)   ! M(H) * Width(H) 
        if(WR(1).lt.Parl(1).or.WR(1).gt.Parl(2)) then
         call X1X2GEN( ParL, X1, X2, Veslum, q1, q2, QQ)
        else
         call X1X2RES( ParL, WR, X1, X2, Veslum, q1, q2, QQ)
        endif
      elseif(ipar(21).eq.3) then
       call X1X2GEN( ParL, X1, X2, Veslum, q1, q2, QQ)
      endif

      call mass2(q1, q2, shat, sgs)
      Rpar(74) = sgs
      Rpar(71) = shat 
      call TXQscale     ! setting Q-scale for PDF( Rpar(3)) and for alpha_s
      call pdf_BT(x1, x2, pdfbt)

      pb(5) = mq(5)
      call LIPS2 (QQ, Ptop, pb, Ves2)

      veslum = veslum * ves2 * pi2_4 / (2.*shat)
      JT = 6
      JB = 5 
       if(abs(IB(iq)).eq.2.or.abs(IB(iq)).eq.4) then
         JU = IB(iq)
         JD = IT(iq)
         Call sng_01(q1, q2, ptop, pb, vesm)
       else
         JU = IT(iq)
         JD = IB(iq)
         Call sng_01(q2, q1, ptop, pb, vesm)
       endif
      I = IB(iq)
      J = IT(iq)
      Xcs( I, J) = Veslum * vesm * pdfBT( I, J) * CKM2(i,j)
      Xcs(-I,-J) = Veslum * vesm * pdfBT(-I,-J) * CKM2(i,j)
       if(i.eq.2.or.i.eq.4.or.J.eq.2.or.J.eq.4) then
        Xcs( I, J) = BRS(1,1)  * Xcs(I,J)
        Xcs(-I,-J) = BRS(2,1)  * Xcs(-I,-J)
       else
        Xcs( I, J) = BRS(2,1) * Xcs(I,J)
        Xcs(-I,-J) = BRS(1,1) * Xcs(-I,-J)
       endif

      sigrx=0.d0
      do I=-5,5
        do J=-5,5
          if(.NOT.first) then 
           xcs(I,J) = xcs(I,J) / (xest(IQ) - xest(IQ-1))
          endif
          sigrx = sigrx + xcs(I,J)
        enddo
      enddo
*
      if(.NOT.first) goto 444
      xest(IQ) = xest(IQ) + sigrx
      goto 100
 111  continue
       
       xest(0) = 0.d0
       do IQ = 1,ncomb
        xest(IQ) = xest(IQ) / ipar(52)
        xest(0)  = xest(0) + xest(IQ)
       enddo
        xest(1) = xest(1) / xest(0) 
       do IQ = 2,ncomb
        xest(IQ) = xest(IQ) / xest(0) 
        xest(IQ) = xest(IQ) + xest(IQ-1) 
       enddo
       xest(0) = 0.d0
       sigrx = 0.d0
      first=.FALSE.
       return       
 444  continue
      NFP = 5
        call TXTQ1SMR(QQ, ptop, pb, ptop1, pb1) 
       do i = 1,5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = ptop1(i) + pb1(i)  ! virtual W or Higgs 
        pus(4,i) = ptop1(i)           ! final top 
        pus(5,i) = pb1(i)             ! final b
       enddo
      return
      end
