*----------------------------------------------------------------------------*
*... Authors  : Serge Slabospitsky                                           *
*... 29.01.2001                                                              *
*    q q~' -> H+- JET -> tau nu                                              *
*............................................................................*
      subroutine gejzer_07(NFP)
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision  pn(5), PL(5)
      double precision  q1(5), q2(5), qq(5) 
      double precision  pu(5), pd(5), pg(5)
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer I, J, L, j1,j2 
      double precision mql, mql2
      common/massql/ mql(0:20), mql2(0:20)
      double precision  x1, x2, sg, sgs

      double precision  ves
      dimension ves(-6:6,-6:6)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision pdfbt(-5:5, -5:5)
      double precision veslum, vesm, ves1, Ves2 
      double precision CKM2
      common /CKMD/ CKM2(-6:6,-6:6)
      double precision sqhat_min, sqhat_max, parl(3) 
      save   sqhat_max, sqhat_min 
      double precision PYR
*
      integer IQ, IK,   LU, LD, LG 
      common /hjetfl/ ik(3)   ! KF code of beam, target, and final
      integer iqb(18), iqt(18), iqf(18)
      data iqb/
     & 2, 2, 2, 4, 4, 4,  2, 2, 2, 4, 4, 4, -1,-3,-5,-1,-3,-5/ 
      data iqt/
     &-1,-3,-5,-1,-3,-5,  0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0/
      data iqf/
     & 0, 0, 0, 0, 0, 0, -1,-3,-5,-1,-3,-5,  2, 2, 2, 4, 4, 4/
      Save IQB, IQT, IQF
      double precision PH(5), pf(5) 
*
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision PARR(4),   PT
      double precision XEST(0:18), aran
      integer II 
      save  XEST
*..............
      if(first) THEN
 999  format(a80)
*..Rpar(51)     : charged Higgs mass                                         
*..Rpar(53)     : total charged Higgs decay width                            
*..RPAR(101)    : sqrt(Shat_MIN) for hard process                          
*..RPAR(102)    : sqrt(Shat_MAX) for hard process                            
*
      If(    Ipar(1).eq.7.or.txpro(7).eq.1) then
        ipar(21) = -1                            ! Ipar(1)=7 : JET + W* -> tau nu 
      ElseIf(Ipar(1).eq.10.or.txpro(10).eq.1) then
        ipar(21) = -2                            ! Ipar(1) = 10 : JET H+- -> tau nu
      EndIf

       sqhat_min = rpar(101)
       sqhat_max = rpar(102)
      write(*,7051) sqhat_min, sqhat_max 
 7051 format(/,' sqrt(Shat) from ',f8.2,' to ',f8.2)
         if(sqhat_min.ge.sqhat_max) then
          write(*,7053) 
 7053    format(/,' Shat_min greater than Shat_max  stop running')
          STOP 
         endif
*

        if(abs(ipar(21)).eq.1) then
         ParR(1) = Rpar(41) 
         ParR(2) = Rpar(44) 
        else 
         ParR(1) = Rpar(51) 
         ParR(2) = Rpar(54) 
        endif
        ParR(3) = sqhat_min
        ParR(4) = sqhat_max
         pn(5) = mql(16)  !  neutrino
         PL(5) = mql(15)
      ENDIF
      
      if(first) goto 103  
       goto 104
 103   continue
       II = 0
 102   II = II + 1
      if(ii.gt.ipar(52)) goto 111
       IQ = 0
 100   IQ = IQ + 1
      if(IQ.GT.18) goto 102
 104   sigrx=0.d0
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*

       if(.NOT.first) then  
 106  aran = PYR(0)
       if(aran.ge.xest(18))   goto 106 
       do IQ = 1,18
        if(aran.le.xest(IQ))  goto 105
       enddo 
 105   continue
      if(IQ.LT.0.OR.IQ.GT.18) goto 106
      endif
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
* 18 combinations are considered
* 1: u d,  2: u s,  3: u b,  4: c d,  5: c s,  6: c b 
* and 6 different variants of (G q -> q`) or (q q~' -> g)
*
* all combinations correspond to H+ production 
      if(pyr(0).gt.0.5) then
       ik(1) = IQB(iq)   
       ik(2) = IQT(iq)
       ik(3) = IQF(iq) 
      else
       ik(2) = IQB(iq)   
       ik(1) = IQT(iq)
       ik(3) = IQF(iq) 
      endif

        q1(5) = mql(abs(ik(1)))     
        q2(5) = mql(abs(ik(2))) 

        pf(5) = mql(abs(ik(3)))
       parL(1) = rpar(103) + dsqrt(sqhat_min**2+rpar(103)**2) 
       parL(2) = Rpar(1)
       parL(3) = Rpar(1)

      call X1X2GEN(parl, X1, X2, Veslum, q1, q2, QQ)
        q1(5) = mql(abs(ik(1)))     
        q2(5) = mql(abs(ik(2))) 
       q1(4) = dsqrt(q1(3)**2 + q1(5)**2) 
       q2(4) = dsqrt(q2(3)**2 + q2(5)**2) 

       veslum = 2.d0 * veslum  ! takes into account beam/target permutation
        call mass2(q1, q2, sg, sgs)

      call LIPS_RES_ONE(QQ, ParR, PH, pf, Ves1)      
*  check for PT(pf) > rpar(103) - min PT(pf)      
      if(pt(pf).lt.rpar(103)) then 
        if(first) goto 100
        return
      endif

      Rpar(5) = PH(5)   ! mass(H* or W*) ==> Q-scale for PDF
      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s    
      call pdf_BT(x1, x2, pdfbt)

      call LIPS2 (PH, pn, pl, Ves2)

        do j1 = -6,6
        do j2 = -6,6
         ves(j1,j2) = 0.d0
        enddo
        enddo
      veslum = veslum * ves1 * ves2 * pi2_4 / (2.*sg)
* all combinations correspond to H+ production 
* in sng_03 :  pU, pD, pG
      

      do i = 1,5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = pf(i) 
      enddo  
       do J = 1,3
        if(abs(ik(j)).eq.2.OR.abs(ik(j)).eq.4)   LU = J
        if(abs(ik(j)).eq.1.OR.abs(ik(j)).eq.3.
     &  OR.abs(ik(j)).eq.5)                      LD = J
        if(abs(ik(j)).eq.0)                      LG = J
       enddo
 
       do J = 1,4
         pu(J) = pus(LU,J) 
         if(LU.eq.3) pu(J) = -pu(J) 
         pd(J) = pus(LD,J) 
         if(LD.eq.3) pd(J) = -pd(J) 
         pg(J) = pus(LG,J) 
         if(LG.eq.1.or.LG.eq.2) pg(J) = -pg(J) 
        enddo
         pu(5) = pus(LU,5) 
         pd(5) = pus(LD,5) 
         pg(5) = pus(LG,5) 
*
         Call sng_03(pu, pd, pg, pn, pl, vesm)
      if    (LG.eq.1.OR.LG.eq.2) then 
       veslum = -veslum / 3.d0 / 8.d0   ! quark*gluon colors
      elseif(LG.eq.3) then
       veslum = veslum / 3.d0 / 3.d0   ! quark*quark colors
      else
       veslum = 0.d0
      endif

      veslum = Veslum * vesm * CKM2(abs(ik(lu)),abs(ik(ld)))
      Xcs( ik(1), ik(2)) = Veslum * pdfBT( ik(1), ik(2))
      Xcs(-ik(1),-ik(2)) = Veslum * pdfBT(-ik(1),-ik(2))

      sigrx=0.d0
      do i= -5 ,5
        do l= -5, 5 
            if(.NOT.first) then 
              xcs(i,l) = xcs(i,l) / (xest(IQ) - xest(IQ-1))
            endif
          sigrx = sigrx + xcs(i,l)
        enddo
      enddo

      if(.NOT.first) goto 444
      xest(IQ) = xest(IQ) + sigrx
      goto 100
 111  continue
       
       xest(0) = 0.d0
       do IQ = 1,18
        xest(IQ) = xest(IQ) / ipar(52)
        xest(0)  = xest(0) + xest(IQ)
       enddo
        xest(1) = xest(1) / xest(0) 
       do IQ = 2,18
        xest(IQ) = xest(IQ) / xest(0) 
        xest(IQ) = xest(IQ) + xest(IQ-1) 
       enddo
       xest(0) = 0.d0
       sigrx = 0.d0
      first=.FALSE.
       return       
 444  continue
       NFP = 6
       do i = 1,5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = pf(i)          ! final quark or gluon 
        pus(4,i) = ph(i)          ! virtual H* or W*
        pus(5,i) = pn(i)          ! final neutrino 
        pus(6,i) = PL(i)          ! final tau
       enddo
      return
      end
