*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  25/12/2000                                  *
*     T Tbar production                                                      *
*     TopReX code = 20                                                       *
*............................................................................*
      subroutine gejzer_20(NFP) 
      Implicit None
      include "txpar.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision p1(5),p2(5),pp1(5),pp2(5),q1(5),q2(5),qq(5)
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision vlum, vestt, vesq, vesg
      integer i, j, j1,j2, j3
      double precision pdfBT(-5:5, -5:5)
      double precision vhh(3,3), vtt
      common /topol2/ vtt(2,3,3)
*.......
      double precision Parl(3) !, TopMV
*..........................      

      sigrx=0.d0
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
*
       p1(5) = mq(6)
       p2(5) = mq(6)
       Parl(1) = p1(5) + p2(5) 
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)
      call X1X2GEN( Parl, X1, X2, Vlum, q1, q2, QQ)
      
      call mass2(q1, q2, sg, sgs) 
      Call LIPS2(QQ, P1, P2, vestt)
      
      Rpar(76) = p1(1)**2 + p1(2)**2     ! pt(top)
      Rpar(75) = dsqrt(Rpar(76))   

      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call pdf_BT(x1, x2, pdfbt)

       do 123 j1 = 1,2
       do 123 j2 = 1,3
       do 123 j3 = 1,3
 123      vtt(j1,j2,j3) = 0.d0

      if(Ipar(22).eq.0.or.Ipar(22).eq.2) then  ! q qbar contribution
        Call QQTTBAR(q1, q2, p1, p2, Vhh, vesQ)
        do i = 1,3
         do j = 1,3
          vtt(2,i,j) = vhh(i,j)  ! qq-> t tbar
         enddo
        enddo
      else
        vesQ = 0.d0  ! ipar(1) = 21 : no qq~ contribution
      endif
*...
      if(Ipar(22).eq.0.or.Ipar(22).eq.1) then  ! gg contribution
       Call GGTTBAR(q1, q2, p1, p2, Vhh, vesG)
        do i = 1,3
         do j = 1,3
          vtt(1,i,j) = vhh(i,j) ! gluon
         enddo
        enddo
      else
        vesG = 0.d0  ! ipar(1) = 22 : no gg contribution
      endif
*.............
      vesQ = Vlum * Vestt * vesQ * pi2_4 / (2.* sg) ! QQ(5)**2
      vesG = Vlum * Vestt * vesG * pi2_4 / (2.* sg) ! QQ(5)**2 
       vesQ = vesQ * BRS(1,1) * BRS(2,1) 
       vesG = vesG * BRS(1,1) * BRS(2,1)

      xcs( 0, 0) = vesG * pdfBT( 0, 0)
      do I = 1,4
       J = -I
       xcs(I,J) = vesQ * pdfBT(I,J)
       xcs(J,I) = vesQ * pdfBT(J,I)
      enddo

      sigrx=0.d0
      do i = -6,6
        do j=-6,6
          sigrx = sigrx + xcs(i,j)
        enddo
      enddo
      NFP = 4

      call TXTTSMR(QQ, p1, p2, pp1, pp2)
        do i=1,5
          pus(1,i) = q1(i)
          pus(2,i) = q2(i)
          pus(3,i) = pp1(i)           ! top quark 
          pus(4,i) = pp2(i)           ! top_bar quark 
        enddo
      return
      end
