*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  06.06.2006                                  *
* TopReX code = 16,  g q -> g T, fcnc, gluon                                 *
*............................................................................*
      subroutine gejzer_33(NFP) 
      Implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision p1(5),p2(5), p3(5), p4(5), pft(5),pfq(5),qq(5)
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs, PT
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision Ves, vlum, VU1, VU2, VC1, VC2, hr(4) 
      double precision pdfBT(-5:5, -5:5)
      integer i, j, iq2, id1, j8,j9 
      integer           idia(4)
      double precision        hrd(5,4)
      common /tplFC_GQ/ idia, hrd
      save /tplfc_GQ/ 
*.......
      double precision Parl(3) !, TopMV
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      integer imatch
      common /wmtch/imatch 
*..........................      
      if(first) THEN
       first=.FALSE.
        if(mid(11,1).eq.-1.AND.mid(12,1).eq.-1) then 
         print*,' '
         print*,'TopReX  FCNC process  ',ipar(1)
         print*,' FCNC (top -> !UP+CHARM! gluon) is switched OFF'
         print*,' stop TopReX run '
         STOP
         return
        endif 
        If(txsel.eq.2)  then
            Rpar(81) = Rpar(68) ! PTmin for q
        Else
            Rpar(81) = Rpar(103) ! PTmin for q
        EndIf 
         if(rpar(81).le.1.d0) rpar(81) = 1.d0
         print*,'TopReX process ',Ipar(1),' PTmin ',Rpar(81)
      ENDIF
***
      imatch = 2
      sigrx=0.d0
      do j8 = -6,6
      do j9 = -6,6
       XCS(j8,j9) = 0.d0
      enddo
      enddo
      call zer5mom(p1) 
      call zer5mom(p2) 

*
       p4(5) = mq(6)
       p3(5) = 0.d0
       Parl(1) = p3(5) + p4(5) 
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)
 100   call X1X2GEN( Parl, X1, X2, Vlum, p1, p2, QQ)
      
      call mass2(p1, p2, sg, sgs)
      Call LIPS2(QQ, P3, P4, ves)
         if(PT(p3).lt.Rpar(81)) then
           NXev(Ipar(1)) = NXev(ipar(1)) + 1
           goto 100
         endif
      Ves = Vlum * Ves * pi2_4 / (2.* sg)
      Rpar(76) = p4(1)**2 + p4(2)**2     ! pt(top)
      Rpar(75) = dsqrt(Rpar(76))   

      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call pdf_BT(x1, x2, pdfbt)
*
      if(mid(11,1).ge.0) then  !  t -> UP gluon
        iq2 = 2 
        call  tfcnc_03(iq2, id1, p1, p2, p3, p4, VU1, hr)
         idia(1) = id1
          do j = 1,4
           hrd(1,j) = hr(j)
          enddo


*        call  tfcnc_03(iq2, id1, p2, p1, p3, p4, VU2, hr11)
*        call tfcnc_03r(iq2, id1, p1, p2, p3, p4, Vc1, hr2)
*        call tfcnc_03r(iq2, id1, p2, p1, p3, p4, Vc2, hr21)
c      print*,'****************' 
c      print*,' srs ',vu1,vu2
c      print*,' rui ',vc1,vc2
c      print*,'RUI/SRS 1 2 ', (vc1/vu1), (vc2/vu2)
c      sp1 = dsqrt(hr(1)**2+hr(2)**2+hr(3)**2)
c      sp11 = dsqrt(hr11(1)**2+hr11(2)**2+hr11(3)**2)
c      sp2  = dsqrt(hr2(1)**2+hr2(2)**2+hr2(3)**2)
c      sp22 = dsqrt(hr21(1)**2+hr21(2)**2+hr21(3)**2)
*      print*,'SRS 1 ', sp1,' ! ', (hr(j),j=1,4)
*      print*,'SRS 2 ', sp11, ' ! ',(hr11(j),j=1,4)
*      print*,'RUI 1 ', sp2,' ! ',(hr2(j),j=1,4)
*      print*,'RUI 2 ', sp22, ' ! ',(hr21(j),j=1,4)
c      print*,'RUI/srs 1 2 ', (sp2/sp1), (sp22/sp11)
c      print*,'RUI/srs 1 ', ((hr(j)/hr2(j)),j=1,3)
c      print*,'RUI/srs 2 ', ((hr11(j)/hr21(j)),j=1,3)


        call tfcnc_03(iq2, id1, p2, p1, p3, p4, VU2, hr)
         idia(2) = id1
          do j = 1,4
           hrd(2,j) = hr(j)
          enddo
      endif
      if(mid(12,1).ge.0) then
        iq2 = 4
        call tfcnc_03(iq2, id1, p1, p2, p3, p4, VC1, hr)
         idia(3) = id1
          do j = 1,4
           hrd(3,j) = hr(j)
          enddo
       call tfcnc_03(iq2, id1, p2, p1, p3, p4, VC2, hr)
        idia(4) = id1
         do j = 1,4
          hrd(4,j) = hr(j)
         enddo
      endif
*
      xcs( 0, 2) = pdfBT( 0, 2) * VES * VU1 * BRS(1,1)
      xcs( 2, 0) = pdfBT( 2, 0) * VES * VU2 * BRS(1,1)
      xcs( 0,-2) = pdfBT( 0,-2) * VES * VU1 * BRS(2,1)
      xcs(-2, 0) = pdfBT(-2, 0) * VES * VU2 * BRS(2,1)

      xcs( 0, 4) = pdfBT( 0, 4) * VES * VC1 * BRS(1,1)
      xcs( 4, 0) = pdfBT( 4, 0) * VES * VC2 * BRS(1,1)
      xcs( 0,-4) = pdfBT( 0,-4) * VES * VC1 * BRS(2,1)
      xcs(-4, 0) = pdfBT(-4, 0) * VES * VC2 * BRS(2,1)

       nfp = 4
      call TXTQ1SMR(QQ, p4, p3, pft, pfq)
       do i = 1, 5
        pus(1,i) =  p1(i)
        pus(2,i) =  p2(i)
        pus(3,i) =  pfq(i) ! final quark
        pus(4,i) =  pft(i) ! final T/Tbar
       enddo
      return
      end
