*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.01.2002                                  *
*     H+ H-   production                                                     *
*............................................................................*
      subroutine gejzer_61(NFP) 
      Implicit None
      include "txpar.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision k1(5), k2(5)        ! H+ and H- 5-momenta
      double precision q1(5), q2(5), qq(5)
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6

      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision vlum, vesq, vesr 
      Integer i, j, iq, II, j1,j2
      double precision pdfBT(-5:5, -5:5)
      double precision Parl(3)
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision XEST(0:5), aran, PYR
      save  XEST
*.......
      if(first) goto 103  
       goto 104
 103   continue
       II = 0
 102   II = II + 1
      if(ii.gt.ipar(52)) goto 111
       IQ = 0
 100   IQ = IQ + 1
       if(IQ.GT.5) goto 102
 104   sigrx=0.d0

       if(.NOT.first) then  
 106  aran = PYR(0)
       if(aran.ge.xest(5))   goto 106 
       do IQ = 1,5
        if(aran.le.xest(IQ))  goto 105
       enddo 
 105   continue
      if(IQ.LT.1.OR.IQ.GT.5) goto 106
      endif
*..
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
* evaluate of the top on-shell mass
       Parl(1) = rpar(51) + rpar(51) 
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)

 295  continue 
      q1(5) = mq(iq) 
      q2(5) = mq(iq)
      call X1X2GEN( Parl, X1, X2, Vlum, q1, q2, QQ)
* check 
      if(QQ(5).lt.Parl(1).or.QQ(5).gt.PARL(2)) goto 295 
 296  continue
      call mass2(q1, q2, sg, sgs)

      call TXQscale   !  setting Q-scale for PDF( Rpar(3)) and for alpha_s  
      call pdf_BT(x1, x2, pdfbt)


      k1(5) = rpar(51)
      k2(5) = rpar(51)
      Call LIPS2(QQ, k1, k2, vesr) 
       vesq = vesr
      call QQHH(iq, q1, q2, k1, k2, vesr) 

      vesQ = Vlum * VesQ * vesr * pi2_4 / (2.* sg)

       xcs( IQ,-IQ) = vesQ * pdfBT( IQ,-IQ) * BRS(1,3)*BRS(2,3)
       xcs(-IQ, IQ) = vesQ * pdfBT(-IQ, IQ) * BRS(1,3)*BRS(2,3)

      sigrx=0.d0
      do i = -6,6
        do j=-6,6
            if(.NOT.first) then 
              xcs(i,j) = xcs(i,j) / (xest(IQ) - xest(IQ-1))
            endif
          sigrx = sigrx + xcs(i,j)
        enddo
      enddo

      if(.NOT.first) goto 444
      xest(IQ) = xest(IQ) + sigrx
      goto 100
 111  continue
       xest(0) = 0.d0
       do IQ = 1,5
        xest(IQ) = xest(IQ) / ipar(52)
        xest(0)  = xest(0) + xest(IQ)
       enddo
        xest(1) = xest(1) / xest(0) 
       do IQ = 2,5
        xest(IQ) = xest(IQ) / xest(0) 
        xest(IQ) = xest(IQ) + xest(IQ-1) 
       enddo
       xest(0) = 0.d0
       sigrx = 0.d0
      first=.FALSE.
       return       
 444  continue

      NFP = 4
        do i=1,5
          pus(1,i) = q1(i)
          pus(2,i) = q2(i)
          pus(3,i) = k1(i)           ! top quark 
          pus(4,i) = k2(i)           ! top_bar quark 
        enddo
      return
      end
