*----------------------------------------------------------------------------*
*... Authors  : Serge Slabospitsky                                           *
*... testing new process                                                     *
*............................................................................*

      subroutine gejzer_test(NFP)
      implicit None
      include "txpar.inc" 
      Integer NFP          
      double precision Pus
      common /user_mom/Pus(20,5)

      double precision Ves, q1(5), b1(5), qq2(5), pq2(5), qq(5) 
      double precision q2(5), b2(5), pl(5), pn(5) 

      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)

      integer I, J, j8,j9 
      double precision  x1, x2, sg, sgs
      double precision  pdfBT(-5:5, -5:5)
      double precision  Veslum, vesQB, vesBQ, ParL(3) ! , TopMV
* 
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision fqwq
      common /sng1fc/ fqwq(4)   !  is factor for weight  
      integer imatch
      common /wmtch/imatch 
*..............
      if(first) THEN
       I = 1
       J = 1
       call qflqw(I, J)
      first=.FALSE.
      ENDIF

      imatch = 1
      sigrx=0.d0
      do j8 = -6,6
      do j9 = -6,6
       XCS(j8,j9) = 0.d0
      enddo
      enddo
      call zer5mom(q1) 
      call zer5mom(q2) 
      PARL(1) = rpar(41)+10.d0 ! p1(5) + 1.d0 ! min sqrt(S_hat) 
      PARL(2) = Rpar(1)      ! max sqrt(S_hat) 
      PARL(3) = Rpar(1)      ! sqrt(S) 

 199  call X1X2GEN(ParL, X1, X2, Veslum, q1, qq2, QQ)
      
      if(qq2(4).lt.mq(5)) goto 199 

      call kinsng1(QQ, q1, qq2, -1)
      sg  = QQ(5)**2
      sgs = QQ(5)
      if(sgs.lt.Parl(1)) return

      b1(5)  = mq(5)
      call Rlip432(QQ, pq2, b1, pl, pn, Ves)
* setting Q-scale for PDF( Rpar(3)) and for alpha_s 
      call TXQscale     
      call pdf_BT(x1, x2, pdfBT) 

       veslum = 2.d0 * veslum * ves  * pi2_4 / (2.*sg)  ! 2 due to QB choice
*
      do j = 1,4
       b2(j) = -qq2(j)
       q2(j) = -pq2(j)
      enddo
        call mwqq(q1, q2, b1, b2, pl, pn, vesqb)
        VesBQ = 0.d0

      VesQB = -VesQB * Veslum 
      VesBQ = -VesBQ * Veslum 

*  top production
      do I = 1,4
       J = I
       if(I.eq.1.or.I.eq.3) J = -I
       Xcs( J, 5) = VesQB * pdfBT( J, 5) * fqwq(I) * BRS(1,1)  ! T
       Xcs(-J,-5) = VesQB * pdfBT(-J,-5) * fqwq(I) * BRS(2,1)  ! Tbar 
       Xcs( 5, J) = VesBQ * pdfBT( 5, J) * fqwq(I) * BRS(1,1)  ! T 
       Xcs(-5,-J) = VesBQ * pdfBT(-5,-J) * fqwq(I) * BRS(2,1)  ! Tbar
      enddo

      sigrx=0.d0
      do i=-5,5
        do j=-5,5
          sigrx = sigrx + xcs(i,j)
        enddo
      enddo

* fill momenta array 
       nfp = 4
      return
      end
