*----------------------------------------------------------------------------*
      subroutine LEPMOMS
      implicit none
      include "txpar.inc" 
      include "hepeup.inc"
      double precision ps1(5), ps2(5), ps3(5), ps4(5), QQ(5)
      common /zzmom/ps1,ps2,ps3,ps4,QQ
      double precision l3p,   l3m,   l4p,   l4m
      common /zzlep/   l3p(5),l3m(5),l4p(5),l4m(5)
      double precision ps(5)

      integer j
*
*  Lorentz transformation into initial frame
      call Lorenb_s(qq, l3p, ps)
       do j = 1,5
        l3p(j) = ps(j)
         enddo
      call Lorenb_s(qq, l3m, ps)
       do j = 1,5
        l3m(j) = ps(j)
         enddo
      call Lorenb_s(qq, l4p, ps)
       do j = 1,5
        l4p(j) = ps(j)
         enddo
      call Lorenb_s(qq, l4m, ps)
       do j = 1,5
        l4m(j) = ps(j)
         enddo
*
      return
      end
