*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   15/02/2005                                 *
*....                                                                        *
      subroutine LEPTEN(ifr, pz, eh, lp, lm, ZLT0, ZLT)
*     ------------------------------------------------                       *
*............................................................................*
      implicit none
      double precision pz(5), q2, R(5)
      double precision lp(5), lm(5) 
      double complex eh(-1:1,4), ZLT(-1:1,-1:1), ZLT0

      double complex EPS4, ee,e1r,e2r
      double precision ml2, vap2, vam2, va2, v0am2, VES
      common /zllc/    ml2, vap2, vam2, va2, V0am2
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      integer i,ip
      double precision eqf(2,-20:20), zff(2,-20:20)
      common /Vboscpl/ eqf, zff
      double precision gv2, ga2
      integer IFR
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
*
*      il = 13
      gv2 = zff(1, ifr)**2
      ga2 = zff(2, ifr)**2
      ml2 = mq2(ifr)
      vam2 = ml2 * (gv2 - ga2)
      Vap2 = (1.d0/2.d0) * (gv2 + ga2)
      Va2  = 2 * zff(1, 11) * zff(2, 11)
      V0am2 = 2.d0 * ml2 * (gv2 - 2*ga2)
*  first Z (p3)

      lp(5) = mq(ifr)
      lm(5) = mq(ifr)

      call LIPS2 (PZ, lp, lm, Ves)
      do i = 1,4
       R(i) = lp(i) - lm(i)
      enddo      
      q2 = pz(5)**2

      do i  = -1, 1
      do ip = -1, 1
      ee  = eh(i,4)*conjg(eh(ip,4)) - eh(i,1)*conjg(eh(ip,1)) 
     &    - eh(i,2)*conjg(eh(ip,2)) - eh(i,3)*conjg(eh(ip,3))
      e1r = eh(i,4)*R(4) - eh(i,1)*R(1)-eh(i,2)*R(2)-eh(i,3)*R(3)
      e2r = conjg(eh(ip,4))*R(4) - conjg(eh(ip,1))*R(1) 
     &    - conjg(eh(ip,2))*R(2) - conjg(eh(ip,3))*R(3)
*
      eps4 = 
     & -conjg(eh(ip,4))*( eh(i,1) * (PZ(2)*R(3) - PZ(3)*R(2))
     &                   -eh(i,2) * (PZ(1)*R(3) - PZ(3)*R(1))
     &                   +eh(i,3) * (PZ(1)*R(2) - PZ(2)*R(1)) )
     & -conjg(eh(ip,1))*(-eh(i,4) * (PZ(2)*R(3) - PZ(3)*R(2))
     &                   +eh(i,2) * (PZ(4)*R(3) - PZ(3)*R(4))
     &                   -eh(i,3) * (PZ(4)*R(2) - PZ(2)*R(4)) )
     & -conjg(eh(ip,2))*( eh(i,4) * (PZ(1)*R(3) - PZ(3)*R(1))
     &                   -eh(i,1) * (PZ(4)*R(3) - PZ(3)*R(4))
     &                   +eh(i,3) * (PZ(4)*R(1) - PZ(1)*R(4)) )
     & -conjg(eh(ip,3))*(-eh(i,4) * (PZ(1)*R(2) - PZ(2)*R(1))
     &                   +eh(i,1) * (PZ(4)*R(2) - PZ(2)*R(4))
     &                   -eh(i,2) * (PZ(4)*R(1) - PZ(1)*R(4)) )
       ZLT(ip,i) = vam2*ee + vap2*((q2-2.d0*ml2)*ee + e1r*e2r)
     &   + (0.d0,1.d0)*va2 * eps4
       ZLT(ip,i) = ves * ZLT(ip,i) 
      enddo
      enddo
* 
      ZLT0 = pi * dsqrt(1.d0 - 4.d0*ml2/pz(5)**2)/2.d0/pi2_6
      ZLT0 = ZLT0 * (2.d0*vap2*pz(5)**2 + V0am2) / 3.d0
      

      return
      end
