
*............................................................................*
* modified by  Serge Slabospitsky                                            *
      subroutine lorenb_s (ps, pi, pf)
*     -------------------------------                                        *
*                                                                            *
*  Lorentz boost pi into pf.  pi is defined in ps REST    frame              *
*                             pf is defined in ps CURRENT frame              *
*  ...(5) are the masses of the particles                                    *
*............................................................................*
*                                                                            *
* cern proglib u102    lorenb          .version kernfor  4.04  821124       *
* orig. 20/08/75 l.pape                                                      *
*............................................................................*
      
      implicit none
      double precision ps(5), pi(5), pf(5), pf4, fn

      if (ps(4).eq.ps(5)) go to 17
      pf4  = (pi(4)*ps(4)+pi(3)*ps(3)+pi(2)*ps(2)+pi(1)*ps(1)) / ps(5)
      fn   = (pf4+pi(4)) / (ps(4)+ps(5))
      pf(1)= pi(1) + fn*ps(1)
      pf(2)= pi(2) + fn*ps(2)
      pf(3)= pi(3) + fn*ps(3)
      pf(4)= pf4
      go to 18
c
   17 pf(1)= pi(1)
      pf(2)= pi(2)
      pf(3)= pi(3)
      pf(4)= pi(4)
c
   18 pf(5) = pi(5)
      return
      end
