*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  23.01.2006                                  *
      double precision FUNCTION massONE(p) 
*     ------------------------------------                                   *
*                                                                            *
*    invariant mass of 4-vector p                                            *
*    massONE = sqrt(p**2), if P**2 < 0, then massONE = -sqrt(-p**2)          *
*............................................................................*

      Implicit none
      double precision p(5)
*
      massone = p(4)**2 - p(1)**2 - p(2)**2 - p(3)**2
      if(massone.ge.0d0) then
        massone =  DSQRT(massone)
      else
        massone = -DSQRT(-massone)
      endif
      return
      end
