*----------------------------------------------------------------------------*
* V^mu = SpinorString * GAMMA^mu(gamma^5) * SpinonColumn 
* GV = gamma^nu * V^nu
*  
      subroutine MATR_ZbA(cg, cv, ca, Gf, Gz, GV) 
*     -------------------------------------------                            *
      implicit none
      double complex cg, cv, ca
      double complex Gf(2,2,4), Gz(2,2,4)
      double complex GV(2,2,4,4)
      integer I, J, K
*
       do i = 1,2
        do j = 1,2
         do k = 1,4
          GF(i,j, k) = (0.d0, 0.d0)
          GZ(i,j, k) = (0.d0, 0.d0)
         enddo
        enddo
       enddo
*
      do I = 1,2
      do j = 1,2    
       GV(I,J,1,3) =  cg*Gf(I,J,4) + (cv-ca)*Gz(I,J,4) 
       GV(I,J,1,4) =  cg*Gf(I,J,2) + (cv-ca)*Gz(I,J,2) 
       GV(I,J,2,3) =  cg*Gf(I,J,1) + (cv-ca)*Gz(I,J,1) 
       GV(I,J,2,4) =  cg*Gf(I,J,3) + (cv-ca)*Gz(I,J,3) 

       GV(I,J,3,1) =  cg*Gf(I,J,3) + (cv+ca)*Gz(I,J,3) 
       GV(I,J,3,2) = -cg*Gf(I,J,2) - (cv+ca)*Gz(I,J,2)
       GV(I,J,4,1) = -cg*Gf(I,J,1) - (cv+ca)*Gz(I,J,1) 
       GV(I,J,4,2) =  cg*Gf(I,J,4) + (cv+ca)*Gz(I,J,4)
      enddo 
      enddo 
      return
      end
