c----------------------------------------------------------------------------c
*-- T. Sjostrandt, ajusted for TopReX S.Slabospitsky, 05/05/2006             *
*   PYTHIA's name is PYANGL                                                  *
*............................................................................*
      double precision FUNCTION PHIANG(P)
*...PHI  CALCULATIONS
      IMPLICIT NONE
      double precision P(5), X, Y, R 
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
 
      PHIANG = 0.d0
       x = p(1)
       y = p(2) 
      R = dsqrt(X**2+Y**2)
      IF(R.LT.1D-20) RETURN
      IF(dABS(X)/R.LT.0.8D0) THEN
        PHIANG = SIGN(dACOS(X/R),Y)
      ELSE
        PHIANG = dASIN(Y/R)
        IF(X.LT.0D0.AND.PHIANG.GE.0D0) THEN
          PHIANG = pi - PHIANG
        ELSEIF(X.LT.0D0) THEN
          PHIANG=-pi - PHIANG
        ENDIF
      ENDIF

      return
      END
