*----------------------------------------------------------------------------*
* product of two complex matrices,  V = A1 * A2
      subroutine PROD_2(A1, A2, v) 
*     ------------------------------                                         *
      implicit none
      double complex A1(4,4), A2(4,4), v(4,4) 
      integer i1, i2 
*
      do i1 = 1,4
       do i2 = 1,4
         v(i1,i2) = A1(i1,1) * A2(1,i2) + A1(i1,2) * A2(2,i2)
     &            + A1(i1,3) * A2(3,i2) + A1(i1,4) * A2(4,i2)
       enddo
      enddo
      RETURN
      END
