*----------------------------------------------------------------------------*
* product A_hat * (M + Phat) * Bhat
      subroutine PROD_3XPY(X, P, Y, v) 
*     ------------------------------                                         *
      implicit none
      double complex X(4,4), P(4,4), Y(4,4), u(4,4),v(4,4) 
*
      v(1,1) = p(1,1) *  (x(1,3)*y(3,1) + x(1,4)*y(4,1))
      v(1,2) = p(1,1) *  (x(1,3)*y(3,2) + x(1,4)*y(4,2))
       v(2,1) = p(1,1) * (x(2,3)*y(3,1) + x(2,4)*y(4,1))
       v(2,2) = p(1,1) * (x(2,3)*y(3,2) + x(2,4)*y(4,2))
      v(3,3) = p(1,1) *  (x(3,1)*y(1,3) + x(3,2)*y(2,3))
      v(3,4) = p(1,1) *  (x(3,1)*y(1,4) + x(3,2)*y(2,4))
       v(4,3) = p(1,1) * (x(4,1)*y(1,3) + x(4,2)*y(2,3))
       v(4,4) = p(1,1) * (x(4,1)*y(1,4) + x(4,2)*y(2,4))
*
      u(1,1) =  x(1,3)*p(3,1) + x(1,4)*p(4,1)
      u(1,2) =  x(1,3)*p(3,2) + x(1,4)*p(4,2)
       u(2,1) = x(2,3)*p(3,1) + x(2,4)*p(4,1)
       u(2,2) = x(2,3)*p(3,2) + x(2,4)*p(4,2)
      u(3,3) =  x(3,1)*p(1,3) + x(3,2)*p(2,3)
      u(3,4) =  x(3,1)*p(1,4) + x(3,2)*p(2,4)
       u(4,3) = x(4,1)*p(1,3) + x(4,2)*p(2,3)
       u(4,4) = x(4,1)*p(1,4) + x(4,2)*p(2,4)
*
      v(1,3) =  u(1,1)*y(1,3) + u(1,2)*y(2,3)
      v(1,4) =  u(1,1)*y(1,4) + u(1,2)*y(2,4)
       v(2,3) = u(2,1)*y(1,3) + u(2,2)*y(2,3)
       v(2,4) = u(2,1)*y(1,4) + u(2,2)*y(2,4)
      v(3,1) =  u(3,3)*y(3,1) + u(3,4)*y(4,1)
      v(3,2) =  u(3,3)*y(3,2) + u(3,4)*y(4,2)
       v(4,1) = u(4,3)*y(3,1) + u(4,4)*y(4,1)
       v(4,2) = u(4,3)*y(3,2) + u(4,4)*y(4,2)

      RETURN
      END
