*----------------------------------------------------------------------------*
*...author :    Serge Slabospitsky  01.03.2004                               *
*                                                                            *
      subroutine TX_GEJZER(NUPS)  
*     ------------------------                                               *
*............................................................................*
      implicit none
      include "txpar.inc" 
      integer    NUPS 
      double precision sigrx,xcs(-6:6,-6:6)
      common/xsecs/sigrx, xcs
      double precision sigpb,xcspb(-6:6,-6:6)
      common/xsecpb/sigpb, xcspb
      save  /xsecpb/
      integer i1,i2
**************
          if    (Ipar(1).eq.1) then
             call gejzer_01(NUPS) !  W-gluon process : 2 -> 2
          elseif(Ipar(1).eq.2) then
             call gejzer_02(nups) !  W-gluon process : 2 -> 3
          elseif(Ipar(1).eq.3) then
            call gejzer_03(nups) !  t W process 
          elseif(Ipar(1).eq.4) then
            call gejzer_04(nups) !  W* -> t bbar process
          elseif(Ipar(1).eq.20)  then 
            call gejzer_20(nups) !  gg (q q~) -> t t~ 
          elseif(Ipar(1).eq.5)  then
            call gejzer_05(nups) !  WQQ~  process
          elseif(Ipar(1).eq.23) then
            call gejzer_23(nups)   ! Z Q Qbar
          elseif(Ipar(1).eq.24) then
            call gejzer_24(nups)   ! gg -> ZZ
          elseif(Ipar(1).eq.25) then
            call gejzer_25(nups)   ! qq -> t tbar gamma
           elseif(Ipar(1).eq.6) then
            call gejzer_06(nups) !  W+  -> tau nu 
          elseif(Ipar(1).eq.7) then
            call gejzer_07(nups) !  JET + W+- ( -> tau nu) 
          elseif(Ipar(1).eq.8) then
            call gejzer_04(nups) !  H* -> t bbar process
          elseif(Ipar(1).eq.9) then
            call gejzer_06(nups) !  H+ -> tau nu 
          elseif(Ipar(1).eq.10) then
           call gejzer_07(nups) !  JET + H+- ( -> tau nu) 
* FCNC + SM
          elseif(Ipar(1).eq.29) then
           call gejzer_29(nups) !   FCNC top production: 2 -> 1
* FCNC process
          elseif(Ipar(1).eq.30) then
            call gejzer_30(nups) !   FCNC top production: 2 -> 1
          elseif(Ipar(1).eq.31) then
            call gejzer_31(nups) !   FCNC top production: q q -> t q
          elseif(Ipar(1).eq.32) then
            call gejzer_32(nups) !   FCNC top production: g g -> t qbar
          elseif(Ipar(1).eq.33) then
            call gejzer_33(nups) !   FCNC top production: g g -> t qbar
          elseif(Ipar(1).eq.34) then
            call gejzer_34(nups) !   FCNC top production: g g -> t qbar
          elseif(Ipar(1).eq.61) then
            call gejzer_61(nups)   ! qq~ -->  H+ H-  
*** for testing only
          elseif(Ipar(1).eq.99) then
            call gejzer_test(nups)   !test 
      else
         write(*,4114) Ipar(1)
 4114    format(3x,'TopReX : UPEVNT',/,
     &          3x,'---------------',/,
     &          3x,'UPEVNT  wrong No for TopReX ',i10,/
     &          3x,'stop TopReX run')
         STOP
      endif
      sigpb = 0.d0
       do i1  = -5,5
        do i2 = -5,5
           xcspb(i1,i2) = xcs(i1,i2) * rpar(18)
           sigpb = sigpb + xcspb(i1,i2)
        enddo
       enddo
       Rpar(65) = sigpb
       Ipar(41) = nups
      return
      end
