c----------------------------------------------------------------------------*
*... author  :  Serge Slabospitsky                                           *
*... 08.04.2002                                                              *
*............................................................................*
*
	Subroutine tx_mtch1(pt,is) 
*	-------------------
*
      Implicit None
      include "txpar.inc"
      include "txpro.inc" 
      integer    nd
      parameter (ND=50) 
      double precision pt,del, ptmin,ptmax
      SAVE del 
      double precision nh1, nh2, xpt 
      common /ahist/nh1(nd), nh2(nd), xpt(nd)
      save /ahist/
      integer I, IS
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      common /promtch/ptmin, ptmax
      SAVE /promtch/ 
***
      IF(first) THEN
       if(txsel.eq.1) then
         ptmin = 5.d0   ! t-channel single top
         ptmax = 25.d0 
       elseif(txsel.eq.2) then
         ptmin =  50.d0   ! FCNC  single top
         ptmax = 150.d0 
       endif

      del = (ptmax - ptmin)/(nd-1)
       do i=1,  nd 
        xpt(i) = ptmin - del/2.0 + del * i  ! 12.08.2003
        nh1(i) = 0.d0
        nh2(i) = 0.d0
       enddo
      first=.FALSE.
      ENDIF
*
      if(pt.lt.ptmin.OR.pt.ge.ptmax) then 
       return
      endif

      do i=1,nd
       if(pt.ge.(xpt(i)-del/2.d0).and.pt.lt.(xpt(i)+del/2.d0)) then
        if(is.eq.1) nh1(i) = nh1(i) + 1.d0
        if(is.eq.2) nh2(i) = nh2(i) + 1.d0
       endif
      enddo
      return
      end
