*----------------------------------------------------------------------------*
      subroutine varzz(p1,p2,p3,p4) 
      implicit none
      include "txpar.inc" 
      double precision mz2, mz4
      common /masszbos/ mz2, mz4
      double precision p1(5), p2(5), p3(5), p4(5), QQ(5)
      double precision ps1(5), ps2(5), ps3(5), ps4(5)
      common /zzmom/ps1,ps2,ps3,ps4,QQ
      integer j
      double precision s,t,u,s2,s4,yr
      common /varz0/s,t,u,s2,s4,yr
      double precision bet, pz, pt, ds, ss, cs, cz,sz
      common /zzbet/ bet
      save /zzbet/ 
*      double complex ep(2,4), em(2,4) ei
*      common /helvec/ep, em
*      save /helvec/
      double complex ex, ey, ez
      double complex ei
      data ei/(0.d0,1.d0)/
      save ei
      double complex e3(-1:1,4), e4(-1:1,4) 
      common /zbospol/ e3, e4
*      integer it1, it2
*      double complex ttt
*
      s = (p1(4)+p2(4))**2 - (p1(1)+p2(1))**2  
     &  - (p1(2)+p2(2))**2 - (p1(3)+p2(3))**2 
      u = (p2(4)-p3(4))**2 - (p2(1)-p3(1))**2  
     &  - (p2(2)-p3(2))**2 - (p2(3)-p3(3))**2 
      t = (p1(4)-p3(4))**2 - (p1(1)-p3(1))**2  
     &  - (p1(2)-p3(2))**2 - (p1(3)-p3(3))**2 
*
      s2 = s - 2.d0*mz2
      s4 = s - 4.d0*mz2
      YR = u*t - mz4
      bet = dsqrt(1.d0 - 4.d0*mz2/s)
      do J = 1,4
       qq(j) = p3(j) + p4(j)
      enddo
       qq(5) = dsqrt(s)
* Lorentz boost to QQ rest frame
      call Lorenf_s(qq, p1, ps1)
      call Lorenf_s(qq, p2, ps2)
      call Lorenf_s(qq, p3, ps3)
      call Lorenf_s(qq, p4, ps4)
* evaluate E3 and E4 helicity vectors in QQ rest frame
      PZ = dsqrt(ps3(4)**2 - mz2)
      ds = 1.d0 / dsqrt(2.d0)
      PT = dsqrt(ps3(1)**2 + ps3(2)**2) 
       cz = ps3(3) / PZ
       sz = pt     / PZ
       cs = ps3(1) / pt
       ss = ps3(2) / pt
* e3+
       e3(1,4) = (0.d0, 0.d0)
        ex = ds * (ei * cz)
        ey = ds
        ez = ds * (-ei * sz)
       e3(1,3) = ez
       e3(1,2) = ss * ex + cs * ey
       e3(1,1) = cs * ex - ss * ey
* e3-
       e3(-1,4) = (0.d0, 0.d0)
        ex = ds * (-ei * cz)
        ey = ds
        ez = ds * (ei * sz)
       e3(-1,3) = ez
       e3(-1,2) = ss * ex + cs * ey
       e3(-1,1) = cs * ex - ss * ey
* e30
       e3(0,4) = PZ / Rpar(45)
        ex = (ps3(4)/rpar(45)) * sz
        ey = (0.d0,0.d0)
        ez = (ps3(4)/rpar(45)) * cz
       e3(0,3) = ez
       e3(0,2) = ss * ex + cs * ey
       e3(0,1) = cs * ex - ss * ey
****
* e4+
       e4(1,4) = (0.d0, 0.d0)
        ex = ds * (-ei * cz)
        ey = ds
        ez = ds * (ei * sz)
       e4(1,3) = ez
       e4(1,2) = ss * ex + cs * ey
       e4(1,1) = cs * ex - ss * ey
* e4-
       e4(-1,4) = (0.d0, 0.d0)
        ex = ds * (ei * cz)
        ey = ds
        ez = ds * (-ei * sz)
       e4(-1,3) = ez
       e4(-1,2) = ss * ex + cs * ey
       e4(-1,1) = cs * ex - ss * ey
* e40
       e4(0,4) =  PZ / Rpar(45)
        ex = -(ps4(4)/rpar(45)) * sz
        ey =  (0.d0,0.d0)
        ez = -(ps4(4)/rpar(45)) * cz
       e4(0,3) = ez
       e4(0,2) = ss * ex + cs * ey
       e4(0,1) = cs * ex - ss * ey

      return
      end
